import globs
from globs import *


###---base class for heads,bodies and armlegs---###
class _Apparel:
    def __init__(self):
        self.defen      = 0
        self.speedPnlty = 0
        self.atk        = 0
        self.stat_descript = [self.defen,self.atk,self.speedPnlty]

        self.display = None
        self.dis_cho = None
        
    def getdisframes(self,imagesheet,choords):
        images = {}
        for i,ele in enumerate(choords):
            image = pygame.Surface((50,50)).convert_alpha()
            image.fill((0,0,0,0))
            image.blit(imagesheet,(0,0),(50*ele[0],50*ele[1],50,50))
            images[i] = image
        return images
    
    def get_display(self):
        self.display = self.getdisframes(graphic["geardisplay"],self.dis_cho)

####---base class for head---####
class _Head(_Apparel):
    def __init__(self):
        _Apparel.__init__(self)
        self.visionPnlty = None 

#####---specific heads---#####
class Norm(_Head):
    def __init__(self):
        _Head.__init__(self)
        self.name = ["norm","normwar"]
        self.dis_cho = [(0,3)]
        self.get_display()
        self.title         = "No headgear"
##        self.stat_descript = []
        self.descript      = "You should really find a helmet."
        
        

class Helm(_Head):
    def __init__(self):
        _Head.__init__(self)
        self.name   = ["helm","helmwar"]
        self.defen  = 1
        self.dis_cho = [(1,3)]
        self.get_display()
        self.title         = "Helmet"
        self.stat_descript = [self.defen,0,0]
        self.descript = "Average defense, average visibility. Just pretty average."

class Sader(_Head):
    def __init__(self):
        _Head.__init__(self)
        self.name   = ["sader","saderwar"]
        self.defen  = 2
        self.dis_cho = [(2,3)]
        self.get_display()
        self.title         = "Crusader Helm"
        self.stat_descript = [self.defen,0,0]
        self.descript = "Great for protection, but limited visibility... seriously."
        
        self.visionPnlty = True #this definately needs a penalty
        self.visimp = "direct circle"

class Diver(_Head):
    def __init__(self):
        _Head.__init__(self)
        self.name   = ["diver","diverwar"]
        self.water  = "breath"
        self.defen  = 1
        self.dis_cho = [(3,3)]
        self.get_display()
        self.title         = "Nemo's Helmet"
        self.stat_descript = [self.defen,0,0]
        self.descript = "Underwater breathing, and you can almost see where you're going. Amazing."
        
        self.visionPnlty = True #this definately needs a penalty
        self.visimp = "center grid"
    

####---base class for bodies---####
class _Body(_Apparel):
    def __init__(self):
        _Apparel.__init__(self)

#####---specific bodies---#####
class Cloth(_Body):
    def __init__(self):
        _Body.__init__(self)
        self.name = "norm"
        self.dis_cho = [(0,6)]
        self.get_display()
        self.title         = "Peasant Clothes"
##        self.stat_descript = []
        self.descript = "Leaves something to be desired in the defense department."

class Chain(_Body):
    def __init__(self):
        _Body.__init__(self)
        self.name = "chain"
        self.defen  = 1
        self.speedPnlty = -1
        self.dis_cho = [(1,6)]
        self.get_display()
        self.title         = "Chainmail"
        self.stat_descript = [self.defen,0,self.speedPnlty]
        self.descript = "What it has in defense it lacks in freedom of movement."

####---base class for armlegs---####
class _Armleg(_Apparel):
    def __init__(self):
        _Apparel.__init__(self)

#####---specific armlegs---#####
class Handsfeet(_Armleg):
    def __init__(self):
        _Armleg.__init__(self)
        self.name = ["norm1","norm2","strike1","strike2"]
        self.dis_cho = [(0,12)]
        self.get_display()
        self.title         = "Basic Shoes"
##        self.stat_descript = []
        self.descript = "Just your basic shoes... Nothing special."
    
###########################################
###---and now for weapons and shields---###
###########################################

###---base class for weapons---###
class _Weapon(_Apparel):
    def __init__(self):
        _Apparel.__init__(self)
        self.atk = 1
        self.damage_on = True ##
        self.mask         = pygame.Mask((50,50))
        self.mask.fill()
        self.rect         = pygame.Rect(-50,-50,50,50)
        self.framechoords = []
        self.frame        = 0
        self.frames       = []
        self.fps          = 15
        self.lastupdated  = 0.0
        
    def getframes(self):
        images = {}
        for i,ele in enumerate(self.framechoords):
            image = pygame.Surface((50,50)).convert_alpha()
            image.fill((0,0,0,0))
##            image.blit(atk_sheet,(0,0),(50*ele[0],50*ele[1],50,50))
            image.blit(graphic["attacks1"],(0,0),(50*ele[0],50*ele[1],50,50))
            images[i] = image
        return images
            
    def attackthisway(self):
        if pygame.time.get_ticks() - self.lastupdated > 1000/self.fps:
                if self.frame == 0:
                    self.sound.play()
                if self.frame != len(self.frames)-1:
                    self.frame += 1
                else:
                    self.frame = 0
                    globs.Player.attack = False
                    self.rect = pygame.Rect(-50,-50,50,50)
                    pygame.event.clear()
                self.lastupdated = pygame.time.get_ticks()

    def attack(self):
        if globs.Player.direction == "right":
            self.rect.topleft = globs.Player.rect.topright
            globs.Surface.blit(self.frames[self.frame],(globs.Player.rect.topright))
            self.attackthisway()
        elif globs.Player.direction == "left":
            self.rect.x,self.rect.y = globs.Player.rect.x-50,globs.Player.rect.y
            globs.Surface.blit(pygame.transform.flip(self.frames[self.frame],True,False),(globs.Player.rect.x-50,globs.Player.rect.y))
            self.attackthisway()
        if globs.Player.direction == "back":
            self.rect.x,self.rect.y = globs.Player.rect.x,globs.Player.rect.y-50
            globs.Surface.blit(pygame.transform.rotate(self.frames[self.frame],90),(globs.Player.rect.x,globs.Player.rect.y-50))
            self.attackthisway()
        if globs.Player.direction == "front":
            self.rect.topleft = globs.Player.rect.bottomleft
            globs.Surface.blit(pygame.transform.rotate(self.frames[self.frame],-90),(globs.Player.rect.bottomleft))
            self.attackthisway()

            
        

####---specific weapons---####
class Unarmed(_Weapon):
    def __init__(self):
        _Weapon.__init__(self)
        self.name = None
    def attack(self):
        pass
    def special(self):
        pass

class Pitch(_Weapon):
    def __init__(self):
        _Weapon.__init__(self)
        self.atk = 2
        self.name = ["pitch1","pitch2"]
        self.framechoords = [(0,1),(1,1),(0,1)]
        self.frames  = self.getframes()
        self.fps     = 10
        self.sound   = soundfx["boing"]
        self.dis_cho = [(1,0)]
        self.get_display()
        self.title         = "Angry Mob Pitchfork"
        self.stat_descript = [0,self.atk,0]
        self.descript = "Should vanquish all foes... Eventually."
    def special(self):
        pass

class Labrys(_Weapon):
    def __init__(self):
        _Weapon.__init__(self)
        self.atk    = 3
        self.name   = ["labrys1","labrys2"]
        self.framechoords = [(0,0),(1,0),(2,0)]
        self.frames  = self.getframes()
        self.sound = soundfx["whoosh"]
        self.dis_cho = [(0,0)]
        self.get_display()
        self.title         = "Mini-Labrys"
        self.stat_descript = [0,self.atk,0]
        self.descript = "Foliage beware !"
    def special(self):
        pass

###---base class for weapons---###
class _Shield(_Apparel):
    def __init__(self):
        _Apparel.__init__(self)
        self.defen = 0
        self.deflect = []

####---specific shields---####
class Unshielded(_Shield):
    def __init__(self):
        _Shield.__init__(self)
        self.name = None
        self.dis_cho = [(7,9)]
        self.get_display()
        self.title         = "No Shield"
##        self.stat_descript = []
        self.descript = "Thats the spirit. Deflect the enemy arrows with your forehead."

class BasicShield(_Shield):
    def __init__(self):
        _Shield.__init__(self)
        self.name = ["shield","shieldATK"]
        self.deflect = ["basic"]
        self.dis_cho = [(0,9)]
        self.get_display()
        self.title         = "Tin Shield"
##        self.stat_descript = []
        self.descript = "Only slightly better than having no shield at all."
        
        
    

    
        
