import pygame,os,sys
from pygame.locals import *

os.environ['SDL_VIDEO_CENTERED'] = '1'

#mixer buffer size reduced to prevent latency issues
pygame.mixer.pre_init(22050, -16, 2, 2048)
pygame.mixer.init()
pygame.init()




#Global variables
FPS = 64.0          
SCREENSIZE = (1200, 700)
FULL = False                

Surface = None      #Screen
Player  = None       #Player object
Level   = None        #Current level
Menu    = None         #Current menu (do i even use this?)
Sides   = None

if FULL:
    Surface = pygame.display.set_mode(SCREENSIZE, FULLSCREEN)
else:
    Surface = pygame.display.set_mode(SCREENSIZE)
    
Visited_Maps = []

isbusy = False #used to stop event gets during certain events


#these serve as a very useful convenience in many functions
DirectDict = {"left"  : (-1, 0),
              "right" : ( 1, 0),
              "back"  : ( 0,-1),
              "front" : ( 0, 1),
              "none"  : ( 0, 0)}
        

DirectList = ["left","right","back","front"]

#directions in binary used currently for push blocks
DirectBin  = {"back" : 0b1000,
              "right": 0b0100,
              "front": 0b0010,
              "left" : 0b0001}

#direction opposites for convenience
DirectOps = {"back" : "front",
             "right": "left",
             "front": "back",
             "left" : "right"}


#Set up fonts (do I even use these?)
basicFont = pygame.font.SysFont("Arial", 48,bold=True)
midFont = pygame.font.SysFont("Arial", 20,bold=True)
btnFont = pygame.font.SysFont("Arial", 11)


#Meh... I ended up writing it after all...
def getgraphics(directory):
    dirlist = os.listdir(directory)
    graphic = {}
    for graf in dirlist:
        if graf[-3:] == "png":
            graphic[graf[:-4]] = pygame.image.load(os.path.join(directory,graf)).convert_alpha()
    return graphic

graphic = getgraphics("graphics")
pallet = {}
pallet[1]   = graphic["texftile"]
pallet[2]   = graphic["aztecsheet"]
pallet[3]   = graphic["dinosheet"]
pallet[4]   = graphic["dungeon1"]
pallet[5]   = graphic["aztectemple"]
pallet[6]   = graphic["aztectemple2"]

def getsoundfx(directory):
    dirlist = os.listdir(directory)
    sounddict = {}
    for sound in dirlist:
        sounddict[sound[:-4]] = pygame.mixer.Sound(os.path.join(directory,sound))
    return sounddict

soundfx = getsoundfx("soundfx")

soundfx["whoosh"].set_volume(0.5)
soundfx["boing"].set_volume(0.8)
soundfx["laze"].set_volume(0.4)
soundfx["heart"].set_volume(0.8)


#########################

if __name__ == "__main__":
    while pygame.event.wait().type != pygame.QUIT:
        pass
    else: pygame.quit();sys.exit()








        
