import pygame,pickle,os,sys
from pygame.locals import *
import globs,spritesetc, mapproc,worldmapRewind,sidestats
from globs import *
from equip import *


class _Protagonist:
    def __init__(self,speed,location,direction="front",frame=1,name=None):
        self.name      = name
        self.speed     = speed
        self.location  = location
        self.frame     = frame
        self.rect      = pygame.Rect(location[0]*50,location[1]*50,50,50)
        self.direction    = direction
        self.olddirection = direction
        self.invincible_timer = 0.0
        self.strobeupdate     = 0.0
        self.strobe           = 0
        self.strobing         = False

        self.visiontest = False # test test test

        self.mapset    = "worldmap1"
##        self.mapset = "dung1"
        self.mapchoords = [4,9]
##        self.mapchoords = [1,1]

        self.dead = False
        self.deathframe = 0
        
    def draw(self):            
        globs.Surface.blit(self.image,self.rect)
            
class Hero(_Protagonist):
    def __init__(self,head,body,armleg,weapon=Unarmed(),shield=Unshielded()):
        _Protagonist.__init__(self,3,(2,12),"right",1)
        self.spritedict=spritegenerate("hero")

        self.walk      = False
        self.attack    = False
        self.knockback = False
        self.knockdir  = (0,0)
        self.knockframe= 1

        self.health     = 28 
        
        self.lastupdated = 0.0
        self.mask = pygame.Mask((30,30))
        self.mask.fill()
        self.fatmask = pygame.Mask((50,50))
        self.fatmask.fill()

        self.inventory = {}
        self.inventory["money"] = 0
        self.inventory["items"] = []
        self.inventory["equipment"] = {}
        self.inventory["equipment"]["heads"]   = []
        self.inventory["equipment"]["bodies"]  = []
        self.inventory["equipment"]["weapons"] = []
        self.inventory["equipment"]["armlegs"] = []
        self.inventory["equipment"]["shields"] = []

        self.equipped  = {}
        self.equipped["head"]   = head
        self.equipped["body"]   = body
        self.equipped["weapon"] = weapon
        self.equipped["armleg"] = armleg
        self.equipped["shield"] = shield
        
        self.head   = self.equipped["head"]
        self.body   = self.equipped["body"]
        self.weapon = self.equipped["weapon"]
        self.armleg = self.equipped["armleg"]
        self.shield = self.equipped["shield"]


        self.updatestats()
        self.fill_equips() #### temp code
        
        self.make_image()
        self.rect = pygame.Rect(self.location[0]*50,self.location[1]*50,50,50)
        self.water = False ##does the hero have something that allows him to cross water?

        self.impair_image = pygame.Surface((1000,700)).convert_alpha() ##

    def updatestats(self):
        self.speedPnlty = 0
        self.defense    = 0
        for equipped in [self.head,self.body,self.armleg]:
            self.speedPnlty += equipped.speedPnlty
            self.defense    += equipped.defen
        self.defense += self.shield.defen
        self.speed   = 3 + self.speedPnlty

    def fill_equips(self):  #this function will be changed or removed later
        #currently it puts all items in the Hero's inventory
        self.inventory["equipment"]["heads"].append(Norm())
        self.inventory["equipment"]["heads"].append(Helm())
        self.inventory["equipment"]["heads"].append(Sader())
        self.inventory["equipment"]["heads"].append(Diver())

        self.inventory["equipment"]["bodies"].append(Cloth())
        self.inventory["equipment"]["bodies"].append(Chain())

        self.inventory["equipment"]["weapons"].append(Pitch())
        self.inventory["equipment"]["weapons"].append(Labrys())

        self.inventory["equipment"]["armlegs"].append(Handsfeet())

        self.inventory["equipment"]["shields"].append(Unshielded())
        self.inventory["equipment"]["shields"].append(BasicShield())
        
        

            
    def facing(self):
        """picks the correct sprite images for a given direction"""
        if self.attack == False:
            self.headS   = self.spritedict[self.direction]["heads"][self.head.name[0]]
            self.bodyS   = self.spritedict[self.direction]["bodies"][self.body.name]
            self.core   = [self.bodyS,self.headS]
            if self.shield.name != None:
                self.shieldS = self.spritedict[self.direction]["shields"][self.shield.name[0]]
            if self.weapon.name != None:
                self.weaponS = [self.spritedict[self.direction]["weapons"][self.weapon.name[0]] ,self.spritedict[self.direction]["weapons"][self.weapon.name[1]]]
            self.armlegS = [self.spritedict[self.direction]["armslegs"][self.armleg.name[0]],self.spritedict[self.direction]["armslegs"][self.armleg.name[1]]]

        else: #pick different frames during an attack
            self.headS   = self.spritedict[self.direction]["heads"][self.head.name[1]]
            self.bodyS   = self.spritedict[self.direction]["bodies"][self.body.name]
            self.core   = [self.bodyS,self.headS]
            if self.shield.name != None:
                self.shieldS = self.spritedict[self.direction]["shields"][self.shield.name[1]]
            self.armlegS = [self.spritedict[self.direction]["armslegs"][self.armleg.name[2]],self.spritedict[self.direction]["armslegs"][self.armleg.name[3]]]
        
        
    def make_image(self):
        """creates the image of the hero taking care to blit clothes in the right order"""
        self.facing()
        if self.attack == False:
            ourhero = pygame.Surface((50,50)).convert_alpha()
            ourhero.fill((0,0,0,0))
            if self.direction == "left" or self.direction == "back":
                if self.shield.name != None:
                    ourhero.blit(self.shieldS,(0,0))
            if self.direction == "right" or self.direction == "back":
                if self.weapon.name != None:
                    ourhero.blit(self.weaponS[self.frame-1],(0,0))

            for piece in self.core:
                ourhero.blit(piece,(0,0)) 

            if self.direction == "front" or self.direction == "left":
                if self.weapon.name != None:
                    ourhero.blit(self.weaponS[self.frame-1],(0,0))
            
            ourhero.blit(self.armlegS[self.frame-1],(0,0))
            
            if self.direction == "front" or self.direction == "right":
                if self.shield.name != None:
                    ourhero.blit(self.shieldS,(0,0))
            self.image = ourhero
            if self.frame == 1: self.frame += 1
            else: self.frame = 1

        else: #pick different frames during an attack
            ourhero = pygame.Surface((50,50)).convert_alpha()
            ourhero.fill((0,0,0,0))
            if self.direction == "left" or self.direction == "front":
                if self.shield.name != None:
                    ourhero.blit(self.shieldS,(0,0))
                for piece in self.core:
                    ourhero.blit(piece,(0,0))
                ourhero.blit(self.armlegS[self.frame-1],(0,0))
            if self.direction == "right" or self.direction == "back":
                for piece in self.core:
                    ourhero.blit(piece,(0,0))
                ourhero.blit(self.armlegS[self.frame-1],(0,0))
                if self.shield.name != None:
                    ourhero.blit(self.shieldS,(0,0))
            self.image = ourhero

        # pain in the ass 8-bit color transformation for damage strobing
        if self.strobing:
            if pygame.time.get_ticks() - self.strobeupdate > 1000/20:
                    newimage = pygame.Surface((50,50))
                    newimage.fill((90,0,90),(0,0,50,50))
                    newimage.blit(self.image,(0,0))
                    newimage = newimage.convert(8)
                    pallette = newimage.get_palette()
                    if self.strobe < 10:
                        if   self.strobe % 2 == 0:   #Hey, I'm Red!
                            for color in pallette:
                                if color[0] + 150 <= 255: color[0]+=150
                                else: color[0] = 255
                            newimage.set_palette(pallette)
                            self.image = newimage
                            self.image.set_colorkey((235,0,85))
                            self.strobe += 1
                        elif self.strobe % 2 == 1:   #Hey, I'm Blue!
                            for color in pallette:
                                if color[2] + 150 <= 255: color[2]+=150
                                else: color[2] = 255
                            newimage.set_palette(pallette)
                            self.image = newimage
                            self.image.set_colorkey((85,0,235))
                            self.strobe += 1
                    else: self.strobing = False
                    
                    self.strobeupdate = pygame.time.get_ticks()
            
                
        

    def update(self):
        def walkthisway(fpsofwalk):
            if pygame.time.get_ticks() - self.lastupdated > 1000/fpsofwalk:
                self.make_image()
                self.lastupdated = pygame.time.get_ticks() 
        def walking():
                (self.maskx,self.masky) = (self.rect.x+10+(self.speed*DirectDict[self.direction][0]),
                                           self.rect.y+20+(self.speed*DirectDict[self.direction][1]))
                if globs.Level.solidmask.overlap_area(self.mask, (self.maskx,self.masky)) == 0:
                    if globs.Level.watermask.overlap_area(self.mask, (self.maskx,self.masky)) == 0:
                        self.rect.x += self.speed*DirectDict[self.direction][0]
                        self.rect.y += self.speed*DirectDict[self.direction][1]
                    elif self.water: #can he traverse water? insert method here
                        pass                        
                walkthisway(7) #should he still march when he can't move forward, or stand still?
                
        def collide_with_object():
            #if the player collides with an active screen object call that objects appropriate function
            self.exact_mask = pygame.mask.from_surface(self.image)
            for key in globs.Level.objects:
                for item in globs.Level.objects[key]:
                    if key == "specials":
                        if self.mask.overlap_area(item.mask, (-(self.rect.x+10+self.speed*DirectDict[self.direction][0])+item.rect.x,
                                                              -(self.rect.y+20+self.speed*DirectDict[self.direction][1])+item.rect.y)) != 0:
                            item.player_collission()  ##all items will be expected to have this function
                    else:
                        if self.exact_mask.overlap_area(item.mask, (-self.rect.x+item.rect.x,-self.rect.y+item.rect.y)) != 0:
                            item.player_collission()  ##all items will be expected to have this function

        def knocked():
            if pygame.time.get_ticks() - self.lastupdated > 1000/30: #the frames per sec this knockback occurs at 
                if self.knockframe <= 3:
                    if globs.Level.solidmask.overlap_area(self.mask, (self.rect.x+10+25*self.knockdir[0],self.rect.y+20+25*self.knockdir[1])) == 0:
                        if globs.Level.watermask.overlap_area(self.mask, (self.rect.x+10+25*self.knockdir[0],self.rect.y+20+25*self.knockdir[1])) == 0:
                            (self.rect.x,self.rect.y) = (self.rect.x + 25*self.knockdir[0],self.rect.y +25*self.knockdir[1])
                            self.knockframe += 1
                        else:
                            self.knockback = False
                            self.knockframe = 1
                    else:
                        self.knockback = False
                        self.knockframe = 1
                else:
                    self.knockback = False
                    self.knockframe = 1
                    
                self.lastupdated = pygame.time.get_ticks()

        def map_change():
            def in_recent():
##                print ("mapchoords: ",self.mapchoords, " (in heroconfig mapchange)")
                for place in globs.Visited_Maps:
                    if worldmapRewind.game_maps[self.mapset][1][tuple(self.mapchoords)] == place.name:
                        globs.Level = place
                        globs.Level.recent_map()
                        break
                else:
                    globs.Level   = mapproc.AMap(globs.Surface,pickle.load(open(os.path.join(worldmapRewind.game_maps[self.mapset][0],
                                                 worldmapRewind.game_maps[self.mapset][1][tuple(self.mapchoords)]),"rb")),
                                                 worldmapRewind.game_maps[self.mapset][1][tuple(self.mapchoords)])
                    globs.Level.getmask()
                    globs.Level.map_specials() ##
                    globs.Level.set_hazards()
                    globs.Level.spawn()

            def draw_these_first(): 
                #paint the items that would normally update after the player (including the player)
                self.draw()
                globs.Level.paintfore()
                globs.Level.objects["projectiles"] = []  #ensures that the same projectiles won't stay on the map until you return
                globs.Sides.update()

            #if player is bumped out of the map completely, change the players direction so that the map changes
            olddirection = self.direction
            if   self.rect.x <=  -40: self.direction = "left"
            elif self.rect.x >=  990: self.direction = "right"
            elif self.rect.y <=  -40: self.direction = "back"
            elif self.rect.y >=  690: self.direction = "front"
            
            if  self.rect.x <= -20 and self.direction == "left":
                draw_these_first() #draw these before map choords change
                self.mapchoords[0] -= 1
                in_recent()
                scroll_map()
                self.rect.x   += 1000
            elif self.rect.x >= 970 and self.direction == "right":
                draw_these_first()
                self.mapchoords[0] += 1
                in_recent()
                scroll_map()
                self.rect.x   -= 1000
            elif self.rect.y <= -20 and self.direction == "back":
                draw_these_first()
                self.mapchoords[1] -= 1
                in_recent()
                scroll_map()
                self.rect.y   += 700
            elif self.rect.y >= 670 and self.direction == "front":
                draw_these_first()
                self.mapchoords[1] += 1
                in_recent()
                scroll_map()
                self.rect.y   -= 700

            #Double check for collision on the next map and attempt to adjust
            #May need to adjust later if player can change maps inside water cells
            #This function provides a little insurance should the player change maps and land slightly inside another solid.
            #Currently it will attempt to shift you 15 pixels in the hopes that it is then clear.
            #Anymore than 15 can be pretty noticable and generally a problem that involves fixing the maps themselves.
            #Ideally this function will never run and a player would really have to try to even trigger it.
            safety = 15
            if self.direction == "left" or self.direction == "right":
                if (globs.Level.solidmask.overlap_area(self.mask, (self.rect.x+10,self.rect.y+20)) != 0 or
                    globs.Level.watermask.overlap_area(self.mask, (self.rect.x+10,self.rect.y+20)) != 0):
##                    print("collission detected. Y started at", self.rect.y)
                    #try moving player up and down 15 pixels and recheck collissions
                    if globs.Level.solidmask.overlap_area(self.mask, (self.rect.x+10,self.rect.y+20+safety)) == 0:
                        if   globs.Level.watermask.overlap_area(self.mask, (self.rect.x+10,self.rect.y+20+safety)) == 0:
                            self.rect.y += safety
                        elif globs.Level.solidmask.overlap_area(self.mask, (self.rect.x+10,self.rect.y+20-safety)) == 0:
                            if globs.Level.watermask.overlap_area(self.mask, (self.rect.x+10,self.rect.y+20-safety)) == 0:
                                self.rect.y -= safety
                    elif globs.Level.solidmask.overlap_area(self.mask, (self.rect.x+10,self.rect.y+20-safety)) == 0:
                        if globs.Level.watermask.overlap_area(self.mask, (self.rect.x+10,self.rect.y+20-safety)) == 0:
                            self.rect.y -= safety
##                    print("fix attempted. Y is now",self.rect.y)
                    
            elif self.direction == "back" or self.direction == "front":
                if (globs.Level.solidmask.overlap_area(self.mask, (self.rect.x+10,self.rect.y+20)) != 0 or
                    globs.Level.watermask.overlap_area(self.mask, (self.rect.x+10,self.rect.y+20)) != 0):
##                    print("collission detected. X started at", self.rect.x)
                    #try moving player up and down 15 pixels and recheck collissions
                    if globs.Level.solidmask.overlap_area(self.mask, (self.rect.x+10+safety,self.rect.y+20)) == 0:
                        if   globs.Level.watermask.overlap_area(self.mask, (self.rect.x+10+safety,self.rect.y+20)) == 0:
                            self.rect.x += safety
                        elif globs.Level.solidmask.overlap_area(self.mask, (self.rect.x+10-safety,self.rect.y+20)) == 0:
                            if globs.Level.watermask.overlap_area(self.mask, (self.rect.x+10-safety,self.rect.y+20)) == 0:
                                self.rect.x -= safety
                    elif globs.Level.solidmask.overlap_area(self.mask, (self.rect.x+10-safety,self.rect.y+20)) == 0:
                        if globs.Level.watermask.overlap_area(self.mask, (self.rect.x+10-safety,self.rect.y+20)) == 0:
                            self.rect.x -= safety
##                    print("fix attempted. X is now",self.rect.x)
            self.direction = olddirection

        def scroll_map():
            #make the next map scroll smoothly on to the screen.
            tempsurf = pygame.Surface((1000,700)).convert_alpha()
            tempsurf.fill((0,0,0,0))
            tempforesurf = pygame.Surface((1000,700)).convert_alpha()
            tempforesurf.fill((0,0,0,0))

            tempmap  = mapproc.AMap(tempsurf,pickle.load(open(os.path.join(worldmapRewind.game_maps[self.mapset][0],worldmapRewind.game_maps[self.mapset][1][tuple(self.mapchoords)]),"rb")),
                                    worldmapRewind.game_maps[self.mapset][1][tuple(self.mapchoords)])

            tempfore  = mapproc.AMap(tempforesurf,pickle.load(open(os.path.join(worldmapRewind.game_maps[self.mapset][0],worldmapRewind.game_maps[self.mapset][1][tuple(self.mapchoords)]),"rb")),
                                    worldmapRewind.game_maps[self.mapset][1][tuple(self.mapchoords)])
            
            for place in globs.Visited_Maps: #update map changes for the scrolling map
                    if worldmapRewind.game_maps[self.mapset][1][tuple(self.mapchoords)] == place.name:
                        tempmap.changes  = place.changes
                        tempfore.changes = place.changes
                        break

            tempmap.getmask()
            tempmap.loadmap()            
            tempfore.getmask()
            tempfore.paintfore()

            now = globs.Surface.copy(); where = 0
            while 1:
                if pygame.time.get_ticks() - self.lastupdated > 1000/65:
                    where += 5
                    globs.Surface.blit(tempsurf,((1000-where)*DirectDict[self.direction][0],(700-where)*DirectDict[self.direction][1]))
                    globs.Surface.blit(self.image,(self.rect.x-where*DirectDict[self.direction][0],self.rect.y-where*DirectDict[self.direction][1]))
                    globs.Surface.blit(now,(-5*DirectDict[self.direction][0],-5*DirectDict[self.direction][1]),(0,0,1000,700))
                    
                    #tunnels, they is a bitch
                    globs.Surface.blit(tempforesurf,((1000-where)*DirectDict[self.direction][0],(700-where)*DirectDict[self.direction][1]))
                    globs.Surface.blit(now,(1000,0),(1000,0,200,700))
                    pygame.display.update()
                    now = globs.Surface.copy()
                    
                    if   self.direction == "left" or self.direction == "right":
                        if where == 1000: break
                    elif self.direction == "back" or self.direction == "front":
                        if where == 700: break
                    self.lasupdated = pygame.time.get_ticks()
            



        #the core of the players update control flow is found here
        map_change()
        if not self.dead:    
            if   self.strobing == True: self.make_image()     #Hey guys, am I flashing?
            elif not self.strobing and not self.knockback and self.strobe == 10:
                self.make_image()
                self.strobe = 0
                           
            if   not self.attack and self.walk: walking()   #hey, I'm walkin' here    
            elif self.attack:   self.weapon.attack()        #hey, I'm attackin' here              
            if self.knockback:
                self.strobing = True
                knocked()                    
            self.draw()
            collide_with_object()
        else: self.dieing()

    def dieing(self):
            A_Heros_Death = spritesetc._Sprite() #generally this class is not made for having its own instances
            A_Heros_Death.framechoords = [(3,1),(4,1),(5,1),(6,1)]
            A_Heros_Death.frames = A_Heros_Death.getframes(graphic["enemysheet"])
            if pygame.time.get_ticks() - self.lastupdated > 1000/3:
                if self.deathframe < 6:
                    if   self.deathframe < 3:
                        self.image = A_Heros_Death.frames[self.deathframe]
                    elif 3 <= self.deathframe < 5: self.image = A_Heros_Death.frames[2]
                    elif self.deathframe == 5:
                        self.image = A_Heros_Death.frames[3]
 
                    self.image = self.image.convert()##
                    self.image.set_colorkey((255,0,255))
                    self.deathframe += 1
                    self.lastupdated = pygame.time.get_ticks()

    def vision_impairment(self):
        self.impair_image.fill((0,0,0))
        self.impair_image.fill((255,0,0),(995,0,5,700))
        
        if self.head.visimp == "direct circle":  #currently used for the Crusader Helmet
            pygame.draw.circle(self.impair_image, (0,0,0,0), (self.rect.centerx+125*DirectDict[self.direction][0],self.rect.centery+125*DirectDict[self.direction][1]), 150)
            if self.direction == "back":
                self.impair_image.fill((0,0,0,0),(self.rect.centerx-250,self.rect.y-200,500,100))
                self.impair_image.fill((0,0,0,0),(self.rect.x-25,self.rect.y,100,100))
            if self.direction == "front":
                self.impair_image.fill((0,0,0,0),(self.rect.centerx-250,self.rect.y+150,500,100))
                self.impair_image.fill((0,0,0,0),(self.rect.x-25,self.rect.y-50,100,100))
            if self.direction == "left":
                self.impair_image.fill((0,0,0,0),(self.rect.x-200,self.rect.centery-250,100,500))
                self.impair_image.fill((0,0,0,0),(self.rect.x,self.rect.y-25,100,100))
            if self.direction == "right":
                self.impair_image.fill((0,0,0,0),(self.rect.x+150,self.rect.centery-250,100,500))
                self.impair_image.fill((0,0,0,0),(self.rect.x-50,self.rect.y-25,100,100))

            globs.Surface.blit(self.impair_image,(0,0))
            
        if self.head.visimp == "center grid": #Used for the Diving Helmet (obviously)
            circlerect = pygame.Rect(self.rect.centerx-200,self.rect.centery-200,400,400)
            pygame.draw.circle(self.impair_image, (255,255,0), self.rect.center, 250)
            pygame.draw.circle(self.impair_image, (0,0,0), self.rect.center, 235)
            pygame.draw.circle(self.impair_image, (0,0,0,0), self.rect.center, 200)

            pygame.draw.line(self.impair_image,(0,0,0),(circlerect.x+100,circlerect.y),(circlerect.x+100,circlerect.y+400),20)
            pygame.draw.line(self.impair_image,(0,0,0),(circlerect.x+300,circlerect.y),(circlerect.x+300,circlerect.y+400),20)
            pygame.draw.line(self.impair_image,(0,0,0),(circlerect.x,circlerect.y+100),(circlerect.x+400,circlerect.y+100),20)
            pygame.draw.line(self.impair_image,(0,0,0),(circlerect.x,circlerect.y+300),(circlerect.x+400,circlerect.y+300),20)

            

            globs.Surface.blit(self.impair_image,(0,0))
            

                   

def spritegenerate(spriteroot):
    """Traverses down directories loading the necessary images at the bottom tier.
    Final return is a three level dictionary of the form Imagelist[way][part][specific_image]"""
    imagelist = {}
    waylist = os.listdir(spriteroot)
    for way in waylist:
        imagelist[way] = {}
        try:  #if something other than a folder is found generate the image list at this level, else keep digging
            partlist = os.listdir(spriteroot+"/"+way)
        except WindowsError:
            imagelist = {way[:-4]:pygame.image.load(os.path.join(spriteroot,way)).convert_alpha() for way in waylist if way[-3:] == "png"}
            return imagelist

        for part in partlist:
            try: #if something other than a folder is found generate the image list at this level, else keep digging
                piecelist = os.listdir(spriteroot+"/"+way+"/"+part)
            except WindowsError:
                imagelist[way] = {part[:-4]:pygame.image.load(os.path.join(spriteroot+"/"+way,part)).convert_alpha() for part in partlist if part[-3:] == "png"}
                return imagelist

            imagelist[way][part] = {piece[:-4]:pygame.image.load(os.path.join(spriteroot+"/"+way+"/"+part,piece)).convert_alpha() for piece in piecelist if piece[-3:] == "png"}
    return imagelist

