import pygame,pickle,os,sys
import spritesetc, worldmapRewind
from pygame.locals import *

import globs
from globs import *



class AMap:
    def __init__(self,screen,mapdata,name):
        self.mapped = mapdata
        self.screen = screen
        self.name   = name
        
        
        self.anim   = 0.0 #animate water
        self.flag   = 0
        
        self.objects    = {}
        self.objects["enemies"]    = []
        self.objects["bosses"]     = []
        self.objects["drop_items"] = []
        self.objects["npc"]        = []
        self.objects["hazards"]    = []
        self.objects["specials"]   = []
        self.objects["portals"]    = []
        self.objects["projectiles"]= []

        self.events = []

        #this dictionary is used for things such as block pushes, explosions and burnt items changeing the map
        self.changes = {}
        self.changes["main"]       = {}
        self.changes["fore"]       = {}
        self.changes["tweaks"]     = {}
        self.changes["background"] = {}
        
        #will be used for persistent map changes that never reset through the course of a game
        self.perm_changes = {}

        
        if self.screen == globs.Surface:
            self.recent_map()        
        
    def loadmap(self):
        def busy_busy(key):
            #a silly function to ensure that the final position of an object is not drawn until
            #its animation is complete
            for change in self.objects["specials"]:
                try:
                    if key == change.newchoords and not change.done:
                        return 1
                except AttributeError:
                    print("color me curious")
                    pass
            else: return 0

        #draw the primary background fill color        
        self.screen.fill(self.mapped["background"]["colour"],(0,0,1000,700))

        # this flag tells the function which water image to load so that waves animate
        # could be used for other types of background animations as well
        if pygame.time.get_ticks() - self.anim > 1000/4:
            if self.flag == 1:
                self.anim = pygame.time.get_ticks()
                self.flag = 0
            else:
                self.anim = pygame.time.get_ticks()
                self.flag = 1

        #draw the background
        for key in self.mapped["background"]:
            if key == "colour": pass
            #the 'elif' sections below animate water
            #if animation is not desired the else block is all that is necessary
            elif self.mapped["background"][key] == (6*50,2*50,50,50) and self.flag == 0:
                self.screen.blit(graphic["bgtiles"],(key[0]-500,key[1]),self.mapped["background"][key])
            elif self.mapped["background"][key] == (6*50,2*50,50,50) and self.flag == 1:
                self.screen.blit(pallet[1],(key[0]-500,key[1]),(0,12*50,50,50))
            else:
                self.screen.blit(graphic["bgtiles"],(key[0]-500,key[1]),self.mapped["background"][key])
                
        #draw any background changes
        for key in self.changes["background"]:
                self.screen.blit(pallet[self.mapped["main"][key][0]],(key[0]-500,key[1]),self.mapped["main"][key][1])

        #draw the layer that the player is on        
        for key in self.mapped["main"]:
            if key not in self.changes["main"] and key not in self.changes["fore"]:
                #the 'if' and 'elif' sections below animate water
                #if animation is not desired the else block is all that is necessary
                if   self.mapped["main"][key] == (1,(3*50,11*50,50,50)) and self.flag == 0:
                    self.screen.blit(pallet[self.mapped["main"][key][0]],(key[0]-500,key[1]),self.mapped["main"][key][1])
                elif self.mapped["main"][key] == (1,(3*50,11*50,50,50)) and self.flag == 1:
                    self.screen.blit(pallet[self.mapped["main"][key][0]],(key[0]-500,key[1]),(0,12*50,50,50))
                else:
                    self.screen.blit(pallet[self.mapped["main"][key][0]],(key[0]-500,key[1]),self.mapped["main"][key][1])

        for key in self.changes["main"]:
            if self.changes["main"][key] != None and not busy_busy(key):
                if   self.changes["main"][key] == (1,(3*50,11*50,50,50)) and self.flag == 0:
                    self.screen.blit(pallet[self.mapped["main"][key][0]],(key[0]-500,key[1]),self.mapped["main"][key][1])
                elif self.changes["main"][key] == (1,(3*50,11*50,50,50)) and self.flag == 1:
                    self.screen.blit(pallet[self.changes["main"][key][0]],(key[0]-500,key[1]),(0,12*50,50,50))
                else:
                    self.screen.blit(pallet[self.changes["main"][key][0]],(key[0]-500,key[1]),self.changes["main"][key][1])
                
    def paintfore(self):
        #draws the cells that the player will pass underneath
        for key in self.mapped["main"]:
            if key in self.forelis and key not in self.changes["fore"]:
                self.screen.blit(pallet[self.mapped["main"][key][0]],(key[0]-500,key[1]),self.mapped["main"][key][1])
            elif key in self.changes["fore"]:
                if self.changes["fore"][key] != "OTHER":  #this flag is a workaround to a hole I dug myself when I wrote the pushblock class
                    self.screen.blit(pallet[self.mapped["main"][key][0]],(globs.Level.changes["fore"][key][0]-500,globs.Level.changes["fore"][key][1]),self.mapped["main"][key][1])
                else:
                    self.screen.blit(pallet[self.changes["main"][key][0]],(key[0]-500,key[1]),self.changes["main"][key][1])
                    
    def spawn(self):
        for (monstertype,speed,location) in self.mapped["enemies"]:
            enemy = spritesetc.EnemyDict[monstertype](speed,location)
        if "boss" in self.mapped:
            for (monstertype,speed,location) in self.mapped["boss"]:
                enemy = spritesetc.BossDict[monstertype](speed,location)
            

    def recent_map(self):
        names=[]
        for place in globs.Visited_Maps:
            names.append(place.name)
        if self.name not in names: 
            globs.Visited_Maps.insert(0,(self))
            if len(globs.Visited_Maps) > 3:
                globs.Visited_Maps.pop()
        else:
            for place in globs.Visited_Maps:
                if place.name == self.name:
                    globs.Visited_Maps.remove(place)
                    globs.Visited_Maps.insert(0,(self))         

    def getlists(self):
        self.waterlis = {}
        self.solidlis = {}
        self.forelis  = {}
        self.hazlis   = {}
   
        for key in self.mapped["tweaks"]:
            if key not in self.changes["tweaks"]:
                if   self.mapped["tweaks"][key]  == 1        : self.solidlis[key] = ((key[0]-500,key[1],50,50))
                elif self.mapped["tweaks"][key]  == 0        : self.waterlis[key] = ((key[0]-500,key[1],50,50))
                elif self.mapped["tweaks"][key]  == "fore"   : self.forelis[key]  = ((key[0]-500,key[1],50,50))
                elif self.mapped["tweaks"][key]  == "solidfore" :
                    self.solidlis[key] = ((key[0]-500,key[1],50,50))
                    self.forelis[key]  = ((key[0]-500,key[1],50,50))
                elif self.mapped["tweaks"][key]  == "hazard" : self.hazlis[key]  = ((key[0]-500,key[1],50,50))

                elif type(self.mapped["tweaks"][key]) is tuple and self.mapped["tweaks"][key][0] == "portal": ###still testing
                    self.objects["portals"].append(Portal(key, self.mapped["tweaks"][key][1],
                                                               self.mapped["tweaks"][key][2],
                                                               self.mapped["tweaks"][key][3]))
                    

        for key in self.changes["tweaks"]:
            if   self.changes["tweaks"][key]  == 1        : self.solidlis[key] = ((key[0]-500,key[1],50,50))
            elif self.changes["tweaks"][key]  == 0        : self.waterlis[key] = ((key[0]-500,key[1],50,50))
            elif self.changes["tweaks"][key]  == "fore"   : self.forelis[key] = ((key[0]-500,key[1],50,50))
            elif self.changes["tweaks"][key]  == "hazard" : self.hazlis[key]  = ((key[0]-500,key[1],50,50))


    def map_specials(self):
        #adds items such as pushblocks, burnblocks and explodeblocks... or at least it will eventually
        self.speclist = {}
        self.speclist["push"]  = {}
        self.speclist["burn"]  = {}
        self.speclist["break"] = {}
        if "specials" in self.mapped:
            for key in self.mapped["specials"]:
                for choord in self.mapped["specials"][key]:
                    if key == "push":
                        self.objects["specials"].append(PushBlock(choord,self.mapped["specials"][key][choord]))
                    if key == "door":
                        if globs.Level.mapped["main"][choord][0] == 4:  #creates a door from the techno pallet
                            self.objects["specials"].append(Tech_Door(choord,self.mapped["specials"][key][choord]))
                        elif globs.Level.mapped["main"][choord][0] == 6:  #creates a door from the techno pallet
                            self.objects["specials"].append(Stone_Door(choord,self.mapped["specials"][key][choord]))
                
    def set_hazards(self):
        #currently used to add cacti
        for key in self.hazlis:
            haz = spritesetc.Hazard((int((key[0]-500)/50),int(key[1]/50)))
            self.objects["hazards"].append(haz)
            

    def getmask(self):
        self.getlists()
        def paintelement(adict,mapdata):
            element = pygame.Surface((1000,700)).convert_alpha()
            element.fill((0,0,0,0))
            for key in adict:
                if key not in self.changes["main"]:
                    element.blit(pallet[mapdata["main"][key][0]],(key[0]-500,key[1]),mapdata["main"][key][1])
                else:
                    element.blit(pallet[self.changes["main"][key][0]],(key[0]-500,key[1]),self.changes["main"][key][1])
            return element
        def paintdense(adict,mapdata):
            dense = pygame.Surface((1000,700)).convert_alpha()
            dense.fill((0,0,0,0))
            for key in adict:
                dense.fill((125,125,125),(key[0]-500,key[1],50,50))
            return dense
                
        solids = paintelement(self.solidlis,self.mapped)
        liquid = paintelement(self.waterlis,self.mapped)

        dsolids= paintdense(self.solidlis,self.mapped)
        dliquid= paintdense(self.waterlis,self.mapped)
        dhazard= paintdense(self.hazlis,self.mapped)
        self.solidmask = pygame.mask.from_surface(solids)
        self.watermask = pygame.mask.from_surface(liquid)
      
        self.dense_solidmask = pygame.mask.from_surface(dsolids)
        self.dense_watermask = pygame.mask.from_surface(dliquid)
        self.dense_hazmask   = pygame.mask.from_surface(dhazard)

    def map_update(self):
        #currently I use this to add an event when all enemies on a map are dead
        if "alldead" not in self.events and self.objects["enemies"] == []:
            self.events.append("alldead")
##            print ("Event 'alldead' added to map events")


        
        

class PushBlock:
    def __init__(self,choords,data):
        self.directions = data[0] #possible directions this block can be pushed in
        self.event_key  = data[1]
        self.choords = choords       #refers to where the block starts, not where it is
        self.newchoords = None       #will be set to the blocks final position
        self.rect = pygame.Rect(choords[0]-500,choords[1],50,50)
        
        self.willpush  = False
        self.pushed    = False
        self.done      = False
        self.pushtimer = 0.0
        self.pushcount = 0

        self.fore1 = False
        self.fore2 = False
        
        self.get_image()
        self.bg = None
        
        
    def get_image(self):
        surfy = pygame.Surface((50,50)).convert_alpha()
        surfy.fill((0,0,0,0))
        surfy.blit(pallet[globs.Level.mapped["main"][self.choords][0]],(0,0),globs.Level.mapped["main"][self.choords][1])
        self.image = surfy
        self.mask = pygame.mask.from_surface(self.image)

    def update(self):
        def still_pushing():
            #if player is no longer pushing reset flags
            globs.Player.exact_mask = pygame.mask.from_surface(globs.Player.image)
            if globs.Player.mask.overlap_area(self.mask, (-(globs.Player.rect.x+10+globs.Player.speed*DirectDict[globs.Player.direction][0])+self.rect.x,
                                                          -(globs.Player.rect.y+20+globs.Player.speed*DirectDict[globs.Player.direction][1])+self.rect.y)) == 0:
                self.willpush = False
            elif globs.Player.walk == False or self.pushdir != globs.Player.direction:
                self.willpush = False
            
        if not self.pushed:
            if self.willpush == True:
                still_pushing()
        elif self.pushed and not self.done:
            if pygame.time.get_ticks() - self.pushtimer > 1000/65:
                try:
                    globs.Level.mapped["main"].pop(self.choords)
                except KeyError: pass
                self.pushcount += 2
                self.rect.x = self.choords[0]-500 + self.pushcount*DirectDict[self.pushdir][0]
                self.rect.y = self.choords[1]     + self.pushcount*DirectDict[self.pushdir][1]

                if self.fore1:  #update a foreground item stacked on the pushable block
                    globs.Level.changes["fore"][self.choords[0],self.choords[1]-50] = [self.choords[0] + self.pushcount*DirectDict[self.pushdir][0],
                                                                                       self.choords[1]-50 + self.pushcount*DirectDict[self.pushdir][1]]
                if self.fore2:  
                    globs.Level.changes["fore"][self.choords[0],self.choords[1]-100] = [self.choords[0] + self.pushcount*DirectDict[self.pushdir][0],
                                                                                       self.choords[1]-100 + self.pushcount*DirectDict[self.pushdir][1]]


                self.pushtimer = pygame.time.get_ticks()
                if self.pushcount == 50:
                    globs.Level.changes["main"][self.choords]   = None
                    globs.Level.changes["tweaks"][self.choords] = None #set the initial square as empty
                    globs.Level.getmask()
                    self.done = True
                    # if the blocks is meant to remain pushable a new push block in the new position must be created here somehow
                    globs.Level.events.append(self.event_key)
                    globs.Level.objects["specials"].remove(self)  
            

        if self.pushed: 
            globs.Surface.blit(self.image,self.rect.topleft)
        
            

    def player_collission(self):
        def can_push():
            #checks if the direction the player pushes is valid for the object
            #and then checks if there are any enemies in the final square
            if int(self.directions,2) & DirectBin[self.pushdir] != 0:
                for enemy in globs.Level.objects["enemies"]:
                    if enemy.rect.colliderect(self.rect.x + 50*DirectDict[self.pushdir][0],self.rect.y + 50*DirectDict[self.pushdir][1],50,50):
                        return 0
                return 1
            else:
                return 0
        
        if pygame.time.get_ticks() - self.pushtimer > 250:
            if not self.willpush:
                self.willpush  = True #willpush is just used for a little delay time between the start of pushing
##                self.playerdir = globs.Player.direction
                self.pushdir = globs.Player.direction
            elif not self.done and not self.pushed and can_push():
                self.newchoords = (self.rect.x + 50*DirectDict[self.pushdir][0]+500,self.rect.y + 50*DirectDict[self.pushdir][1])
                globs.Level.changes["tweaks"][self.newchoords] = 1 #set the new location as solid
                
                if self.newchoords in globs.Level.mapped["main"]:  #don't ruin the background after push    
                    globs.Level.changes["background"][self.newchoords] = (globs.Level.mapped["main"][self.newchoords][0],globs.Level.mapped["main"][self.newchoords][1])
                    if self.newchoords in globs.Level.mapped["tweaks"]: #don't mistake foreground for background
                        if globs.Level.mapped["tweaks"][self.newchoords] == "fore":
                            globs.Level.changes["background"].pop(self.newchoords)
                    
                globs.Level.changes["main"][self.newchoords] = (globs.Level.mapped["main"][self.choords][0],globs.Level.mapped["main"][self.choords][1])

                #could try to extrapulate to handle a stack of 'n' foreground blocks but for now it will only do two max
                if (self.choords[0],self.choords[1]-50) in globs.Level.mapped["tweaks"]:
                    if globs.Level.mapped["tweaks"][self.choords[0],self.choords[1]-50] == "fore":
                        globs.Level.changes["fore"][self.choords[0],self.choords[1]-50] = [self.choords[0],self.choords[1]-50]
                        self.fore1 = True

                if (self.choords[0],self.choords[1]-100) in globs.Level.mapped["tweaks"]:
                    if globs.Level.mapped["tweaks"][self.choords[0],self.choords[1]-100] == "fore":
                        globs.Level.changes["fore"][self.choords[0],self.choords[1]-100] = [self.choords[0],self.choords[1]-100]
                        self.fore2 = True
                
                globs.Level.getmask()
                self.pushed = True
                
            self.pushtimer = pygame.time.get_ticks()

class Portal:
    #a class for internal portals on maps.. does not include edge of map map-changes
    def __init__(self,position,mapset,mapchoords,playerchoords):
        self.mapset = mapset #name of the mapset portal leads to
        self.mapchoords = mapchoords #choords of the map within the set that portal leads to
        self.playerchoords = playerchoords #starting position of player on next map
        self.position = position #where is the portal on the map

        self.mask = pygame.Mask((50,50))
        self.mask.fill()
        self.rect = pygame.Rect(position[0]-500,position[1],50,50)

    def update(self): pass

    def player_collission(self):
        #if the players mask is completely within the portal, then change map
        if globs.Player.mask.overlap_area(self.mask, (-(globs.Player.rect.x+10)+self.rect.x,-(globs.Player.rect.y+20)+self.rect.y)) == 900:
            globs.Level = AMap(globs.Surface,pickle.load(open(os.path.join(worldmapRewind.game_maps[self.mapset][0],
                               worldmapRewind.game_maps[self.mapset][1][tuple(self.mapchoords)]),"rb")),
                               worldmapRewind.game_maps[self.mapset][1][tuple(self.mapchoords)])
            globs.Level.getmask()
            globs.Level.set_hazards()
            globs.Level.map_specials() 
            globs.Level.spawn()
            
            globs.Player.rect = pygame.Rect(self.playerchoords[0]*50,self.playerchoords[1]*50,50,50)
            globs.Player.mapset = self.mapset
            globs.Player.mapchoords = self.mapchoords
        else: pass

class _Door:
    #class for tagging doors that are closed until a certain event occurs
    def __init__(self,choords,event_key):
        self.event_key = event_key  #if this string is found in the current maps events list the door will open
##        print(self.event_key)
        self.open        = False
        self.animatedone = False
        self.choords     = choords
        self.mask = pygame.Mask((50,50))
        self.mask.fill()#test#
        self.rect = pygame.Rect(choords[0]-500,choords[1],50,50)
##        print(globs.Level.mapped["main"][self.choords][0],globs.Level.mapped["main"][self.choords][1])

        self.pallet      = globs.Level.mapped["main"][self.choords][0]
        self.targetrect  = globs.Level.mapped["main"][self.choords][1]
        self.targchoord  = (self.targetrect[0],self.targetrect[1])
        
        self.change_dict = {}
        self.mychanges   = {}

        self.newchoords = "NA" #these are not used but the protocol for specials expects them to exist
        self.done       = "NA"
        self.collidetest = False #test
        
    def animate(self):
        self.animatedone = True
        self.open        = True

    def update(self):
        if not self.collidetest and globs.Player.fatmask.overlap_area(self.mask, (-(globs.Player.rect.x)+self.rect.x,-(globs.Player.rect.y)+self.rect.y)) != 0:                                       
            globs.Level.events.append(self.event_key)   #test#
        if self.event_key in globs.Level.events and self.animatedone == False:
            self.animate()
        elif self.open == True:
            self.opendoor()
        self.collidetest = True #test#

    def player_collission(self):
        pass

    def opendoor(self):
        #put the list changes here
        for key in self.mychanges:
            if key == self.choords:
                globs.Level.changes["main"][key]   = (self.pallet,(self.mychanges[key][0],self.mychanges[key][1],50,50))
                globs.Level.changes["fore"][key]   = "OTHER"
                globs.Level.changes["tweaks"][self.choords] = "fore"
            else:
                globs.Level.changes["main"][key]   = (self.pallet,(self.mychanges[key][0],self.mychanges[key][1],50,50))
        
        globs.Level.getmask()
        globs.Level.objects["specials"].remove(self) 
        
        

class Tech_Door(_Door):
    def __init__(self,choords,event_key):
        _Door.__init__(self,choords,event_key)

        #creat a dictionary of (key = location of closed door) : (value = location of opened door)
        #unfortunately these locations on the pallet don't follow any order so this is arduous
        self.change_dict[(150,100)] = (150, 50) #S facing door
        self.change_dict[(100,100)] = (100, 50)
        self.change_dict[(200,100)] = (200, 50)
        self.change_dict[( 50,600)] = ( 50,550)
        self.change_dict[(100,600)] = (100,550)
        
        self.change_dict[(200,450)] = (200,500) #N facing door
        self.change_dict[(150,450)] = (150,500)
        self.change_dict[(250,450)] = (250,500)
        self.change_dict[(150,600)] = (150,550)
        self.change_dict[(200,600)] = (200,550)

        self.change_dict[( 50,150)] = (  0,250) #E facing door
        self.change_dict[( 50,100)] = (  0,200)
        self.change_dict[( 50,200)] = (  0,300)
        self.change_dict[(250,550)] = (  0,350)
        self.change_dict[(250,600)] = (  0,400)

        self.change_dict[( 50,300)] = (350,200) #W facing door
        self.change_dict[( 50,250)] = (350,150)
        self.change_dict[( 50,350)] = (350,250)
        self.change_dict[(300,550)] = (350,300)
        self.change_dict[(300,600)] = (350,350)

        if self.targchoord == (150,100) or self.targchoord == (200,450):            
            left  = globs.Level.mapped["main"][(self.choords[0]-50,self.choords[1])][1]
            right = globs.Level.mapped["main"][(self.choords[0]+50,self.choords[1])][1]
            self.mychanges[(self.choords[0],self.choords[1])]    = self.change_dict[self.targchoord]
            self.mychanges[(self.choords[0]-50,self.choords[1])] = self.change_dict[(left[0],left[1])]
            self.mychanges[(self.choords[0]+50,self.choords[1])] = self.change_dict[(right[0],right[1])]

        elif self.targchoord == (50,150) or self.targchoord == (50,300):
            up   = globs.Level.mapped["main"][(self.choords[0],self.choords[1]-50)][1]
            down = globs.Level.mapped["main"][(self.choords[0],self.choords[1]+50)][1]
            self.mychanges[(self.choords[0],self.choords[1])]    = self.change_dict[self.targchoord]
            self.mychanges[(self.choords[0],self.choords[1]-50)] = self.change_dict[(up[0],up[1])]
            self.mychanges[(self.choords[0],self.choords[1]+50)] = self.change_dict[(down[0],down[1])]

class Stone_Door(_Door):
    def __init__(self,choords,event_key):
        _Door.__init__(self,choords,event_key)
        self.pallet -= 1

        self.change_dict[(250,150)] = (150, 50)
        self.change_dict[(250,200)] = (150,300)
        self.change_dict[(300,150)] = ( 50,250)
        self.change_dict[(300,200)] = (300,250)

        self.mychanges[self.choords] = self.change_dict[self.targchoord]
    



