import pygame,sys,os,pickle

try:
    from tkinter import *
    from tkinter.filedialog import askopenfilename
    from tkinter.filedialog import asksaveasfilename
    from tkinter.filedialog import askdirectory
    notk = False
except ImportError:
    from Tkinter import *
    from tkFileDialog import askopenfilename
    from tkFileDialog import asksaveasfilename
    from tkFileDialog import askdirectory
    notk = True


import levcreatorRewind,levtweakerRewind,mapprocRewind #levcreatorRewind initializes the screen and loads the graphics
from pygame.locals import *


class WorldMap:
    def __init__(self,screen):
        self.directory = None
        
        self.map_images = [] #list of the map images 
        self.maplist    = [] #list of the map filenames

        self.cellchoords    = {}
        self.paintworld     = {}
        self.worlddict      = {}

        #new vars in this version
        self.target         = (None,None)

        #choordinate sets that have very useful names
        self.x,self.y       = None,None
        self.i,self.j       = None,None
        self.f1,self.f2     = None,None
        self.d1,self.d2     = None,None

        
        self.state          = "GENERATE"
        self.genReady       = False
        self.editReady      = False
        self.screen         = screen
        self.now            = pygame.Surface((1500,700)).convert()

        self.showgrid       = True
        self.editmode       = False

        self.editfile = None ##
        self.pending  = False

        self.load_dir()
        #default to the main world map directory if user hits cancel button
        if self.directory == "":
            self.directory = "world"
            self.finish_load()
        
    def maps_in_dir(self):
        #This function attempts to solve the problem of the list order changing when new maps are added
        #If files are added to the directory the order and thereby previous worldmap will not change.
        #However, if the user deletes maps from a directory "maplist.ls" should also be deleted and the map
        #recreated.
        dirlist = os.listdir(self.directory)
        try:
            self.maplist = pickle.load(open(os.path.join(self.directory,"maplist.ls"),'rb'))
        except (IOError,ValueError):
            self.maplist = []
        for item in dirlist:
            if item[-3:] == "mpt":
                if item not in self.maplist:
                    self.maplist.append(item)
                    print("Appending '",item,"'") 
        #resave the list with current changes
        filename = open(os.path.join(self.directory,"maplist.ls"),'wb')
        pickle.dump(self.maplist,filename)
        filename.close()
        
            
    def generate_maps(self):
        if not self.genReady:
            basicFont = pygame.font.SysFont("Arial", 72)
            self.screen.blit(basicFont.render("Please wait while maps are generated",0,(255,255,255)),(300,250))
            self.genReady = True
        else:
            self.maps_in_dir() 
            for i in range(len(self.maplist)):
                self.map_images.append(pygame.Surface((1000,700)).convert_alpha())
                self.map_images[i].fill((0,0,0,0))
                
            for j,mapname in enumerate(self.maplist):
                thisMap = mapprocRewind.AMap(self.map_images[j],pickle.load(open(os.path.join(self.directory,mapname),"rb")),mapname)
                thisMap.loadmap();thisMap.getmask();thisMap.paintfore()
            self.state = "SHRINK"

    def shrink_map(self):
        self.screen.fill((0,0,0,0))
        self.screen.fill((255,0,0),(480,0,20,700))
        #the counting logic gets sloppy, but I don't care
        i = 0;j=0    
        for x,mapname in enumerate(self.maplist):
            shrunk = pygame.transform.scale(self.map_images[x], (80, 56))
            self.screen.blit(shrunk,(0+i*80,0+j*56))
            self.cellchoords[(i,j)] = mapname
            i+=1
            if i == 6: i = 0; j += 1
        self.screen.blit(levcreatorRewind.graphic["mapmenu"],(50,500))
        self.state = "EDIT"
            
    def editworld(self):
        if not self.editReady:
            self.now = self.screen.copy()
            if self.pending:
                #adds a newly created map to the dicts so it will immediately appear in its new location on the world map
                self.worlddict[(self.f1,self.f2)]  = self.maplist[-1]
                self.paintworld[(self.d1,self.d2)] = ('null',((len(self.maplist)%6-1)*80,(int(len(self.maplist)/6))*56,80,56))
                self.pending = False
            self.paintfromdict()
            self.select_rects()
            self.editReady = True
        for click in pygame.event.get():
                if click.type == pygame.MOUSEBUTTONDOWN:
                    hit = pygame.mouse.get_pressed()
                    if hit[0]:
                        self.target = (int(pygame.mouse.get_pos()[0]*levcreatorRewind.scalefactor[0]),
                                       int(pygame.mouse.get_pos()[1]*levcreatorRewind.scalefactor[1]))
                        if self.editmode == False:
                            #select image from pallet
                            if 0 <= self.target[0] <= 480 and 0 <= self.target[1] < 504:
                                self.x, self.y = int(self.target[0]/80)*80, int(self.target[1]/56)*56
                                self.i, self.j = int(self.x/80),int(self.y/56)
                                
                                self.screen.blit(self.now,(0,0),(0,0,480,505))
                                self.screen.fill((255,0,0),(480,0,5,700))
                                pygame.draw.rect(self.screen,(255,255,0),(self.x,self.y,80,56),2)                                

                            #paint selected image on the screen
                            elif 500 <= self.target[0] <= 1460 and 0 <= self.target[1] <= 672:
                                #why did I offset by 20??? I did this for the gap of the red strip...
                                #but it is causing a targeting issue.
                                #solution: if I offset the final draw point, targetting must be offset
                                #in the opposite direction.
                                d1,d2 = int((self.target[0]-20)/80)*80+20, int(self.target[1]/56)*56 
                                f1,f2 = int((d1-20)/80)-6,int(d2/56)
##                                print (f1,f2)
                                if (self.x,self.y) != (None,None) and (self.i,self.j) != (None, None):
                                    try:
                                        self.worlddict[(f1,f2)]  = self.cellchoords[(self.i,self.j)]
                                        self.paintworld[(d1,d2)] = ('null',(self.x,self.y,80,56))
                                    except KeyError:
                                        print ("Nothing Selected")
                                else: print("select something you idiot")

                        #select a map to edit
                        elif self.editmode == True:
                            self.target = (int(pygame.mouse.get_pos()[0]*levcreatorRewind.scalefactor[0]),
                                       int(pygame.mouse.get_pos()[1]*levcreatorRewind.scalefactor[1]))
                            self.d1,self.d2 = int((self.target[0]-20)/80)*80+20, int(self.target[1]/56)*56
                            self.f1,self.f2 = int((self.d1-20)/80)-6,int(self.d2/56)
                            if 500 <= self.target[0] <= 1460 and 0 <= self.target[1] <= 672:
                                if ((self.d1,self.d2)) in self.paintworld:
                                    self.editfile = os.path.join(self.directory,self.worlddict[(self.f1,self.f2)])
                                    self.genReady  = False
                                    self.editReady = False
                                    self.state = "EDITMAP"
                                else:
                                    self.genReady  = False
                                    self.editReady = False
                                    self.state = "EDITNEWMAP"
                            
                        #turn grid on and off
                        if 370 <= self.target[0] <= 425 and 585 <= self.target[1] <= 605:
                            self.showgrid = True
                            self.select_rects()
                        elif 300 <= self.target[0] <= 355 and 585 <= self.target[1] <= 605:
                            self.showgrid = False
                            self.select_rects()
                        #turn map edit mode on and off
                        elif 145 <= self.target[0] <= 200 and 585 <= self.target[1] <= 605:
                            self.editmode = True
                            self.select_rects()
                        elif 75 <= self.target[0] <= 130 and 585 <= self.target[1] <= 605:
                            self.editmode = False
                            self.select_rects()

                        #saving
                        elif 50 <= self.target[0] <= 130 and 650 <= self.target[1] <= 700:
                            mapdata = {}
                            mapdata["paint"]       = self.paintworld
                            mapdata["world"]       = self.worlddict
                            try:
                                filename = open(asksaveasfilename(),'wb')
                                pickle.dump(mapdata,filename)
                                filename.close()
                            except IOError: pass

                        #loading
                        elif 370 <= self.target[0] <= 450 and 650 <= self.target[1] <= 700:
                            self.load_dir()

                    #delete a map from the working world map
                    elif hit[2] and not self.editmode:
                        self.target = (int(pygame.mouse.get_pos()[0]*levcreatorRewind.scalefactor[0]),
                                       int(pygame.mouse.get_pos()[1]*levcreatorRewind.scalefactor[1]))
                        d1,d2 = int((self.target[0]-20)/80)*80+20, int(self.target[1]/56)*56
                        f1,f2 = int((d1-20)/80)-6,int(d2/56)
                        if ((d1,d2)) in self.paintworld and 500 <= self.target[0] <= 1460 and 0 <= self.target[1] <= 672:
                            self.paintworld.pop((d1,d2))
                            self.worlddict.pop((f1,f2))
                            
                                                  
                if click.type == QUIT: self.state = "QUIT"
        self.paintfromdict()
        
                
    def load_dir(self):
        #initially request a directory to use maps from
        self.directory = askdirectory(initialdir="maps",  title='Please select the directory which contains the maps that you would like to work with:')
        if self.directory != "":
            self.finish_load()
        
    def finish_load(self):   
        dirlist = os.listdir(self.directory)
        for item in dirlist:
            if item[-3:] == "wld":
                loaddata = pickle.load(open(os.path.join(self.directory,item),'rb'))         
                self.worlddict  = loaddata["world"]
                self.paintworld = loaddata["paint"]
        self.state      = "GENERATE"
        self.genReady   = False
        self.editReady  = False
        
    def paintfromdict(self):
        self.screen.fill((0,0,0),(500,0,1000,700))
        for key in self.paintworld:
            self.screen.blit(self.now,key,self.paintworld[key][1])
        self.grid_lines()

    def grid_lines(self):
        if self.showgrid:
            for line in range(12):
                self.screen.fill((255,0,0),((579+80*line),0,2,700))
                self.screen.fill((255,0,0),(500,55+56*line,1000,2))
        self.screen.fill((255,0,0),(1460,0,40,700))
        self.screen.fill((255,0,0),(500,672,1000,28))
        self.screen.fill((255,0,0),(485,0,15,700))
        self.screen.fill((255,255,0),(1462,0,2,676))
        self.screen.fill((255,255,0),(496,674,966,2))
        self.screen.fill((255,255,0),(496,0,2,676))

    def select_rects(self):
        #Is the grid visible?
        #Is map edit selection enabled?
        self.screen.blit(levcreatorRewind.graphic["mapmenu"],(50,510),(0,10,400,190))
        if self.showgrid == True:
            pygame.draw.rect(self.screen,(255,0,0),(50+320,500+85,55,20),3)
        else:
            pygame.draw.rect(self.screen,(255,0,0),(50+250,500+85,55,20),3)
        if self.editmode == True:
            pygame.draw.rect(self.screen,(255,0,0),(50+95,500+85,55,20),3)
        else:
            pygame.draw.rect(self.screen,(255,0,0),(50+25,500+85,55,20),3)

    def update(self):
            if self.state == "GENERATE":
                self.generate_maps()
            elif self.state == "SHRINK":
                self.shrink_map()
            elif self.state == "EDIT":
                self.editworld()
            elif self.state == "QUIT":
                pygame.quit();Tk().quit();sys.exit()


class All_in_one_maps():
    #attempting to amalgamate all map editors into one program
    def __init__(self):
        self.prime_state = "WORLD" #don't know if I need this
    
    def main(self):
        myMap   = levcreatorRewind.Newmap(levcreatorRewind.realscreen)
        myMap.accessed = True 
        
        myTweak = levtweakerRewind.Tweaker(levcreatorRewind.realscreen)
        myTweak.accessed = True
        
        myWorld = WorldMap(levcreatorRewind.realscreen)
        Active = myWorld
        while 1:
            if myWorld.state == "EDITMAP" or myTweak.state == "EDITMAP":
                Active = myMap
                if myMap.bgready == True:
                    myMap.load_map(myWorld.editfile)
                    myWorld.state = "GENERATE"
                    myTweak.state = "TWEAK"
            if myMap.state == "WORLD" or myTweak.state == "WORLD":
                Active = myWorld
                myMap.state   = "BACK"
                myTweak.state = "TWEAK"
            if myMap.state == "TWEAK" or myWorld.state == "TWEAK":
                Active = myTweak
                if myTweak.tweakReady == True:
                    myTweak.load_map(myWorld.editfile)
                    myMap.state   = "BACK"
                    myWorld.state = "GENERATE"
                    
            if myWorld.state == "EDITNEWMAP":
                myMap.__init__(levcreatorRewind.realscreen)
                myMap.accessed = True
                myMap.addnew   = True 
                myTweak.__init__(levcreatorRewind.realscreen)
                myTweak.accessed = True
                myWorld.editfile = "pending"
                Active = myMap
                levcreatorRewind.realscreen.fill((0,0,0),(500,0,1000,700))
                myWorld.state = "GENERATE"

            #overly complicated way that new maps are displayed directly after being created.
            #seems to work for the moment.
            if myWorld.editfile == "pending" and myMap.addednew == True:
                myWorld.pending  = True
                myWorld.editfile = myMap.savedas
                myMap.addednew   = False

            if myWorld.editfile != "pending" and myMap.savedas != None:
                myWorld.editfile = myMap.savedas
                myMap.savedas = None
                
            Active.update()
            
            shrinkscreen = pygame.transform.scale(Active.screen,(levcreatorRewind.size))
            levcreatorRewind.screen1.blit(shrinkscreen,(0,0))
            pygame.display.update()
    
#####
if __name__ == "__main__":
    doitall = All_in_one_maps()
    doitall.main()


