import globs
from globs import *



class SideBar:
    def __init__(self):
        self.allframes = []
        self.howmuchhealth = 0

        self.red    = [(0,1),(0,0)]
        self.orange = [(1,2),(1,1),(1,0),]
        self.yellow = [(2,3),(2,2),(2,1),(2,0)]
        self.green  = [(3,4),(3,3),(3,2),(3,1),(3,0)]

        self.redframes    = self.getframes(graphic["healthsheet"],self.red); self.allframes.append(self.redframes)
        self.orangeframes = self.getframes(graphic["healthsheet"],self.orange); self.allframes.append(self.orangeframes)
        self.yellowframes = self.getframes(graphic["healthsheet"],self.yellow); self.allframes.append(self.yellowframes)
        self.greenframes  = self.getframes(graphic["healthsheet"],self.green); self.allframes.append(self.greenframes)

        self.allframes_times2 = self.allframes*2

        self.image = pygame.Surface((200,700)).convert_alpha()
        self.image.fill((0,0,0,0))        
    
    def getframes(self,imagesheet,framechoords):
        images = {}
        for i,ele in enumerate(framechoords):
            image = pygame.Surface((35,35)).convert_alpha()
            image.fill((0,0,0,0))
            image.blit(imagesheet,(0,0),(35*ele[0],35*ele[1],35,35))
            images[i] = image
        return images

    def paint_health(self):
        self.howmuchhealth = 0
        for i,color in enumerate(self.allframes_times2):
            for cell in sorted(color):
                if self.howmuchhealth != globs.Player.health and globs.Player.health > 0:
                    if self.howmuchhealth < 14:
                        self.image.blit(color[cell],(15+45*i,50))
                    else:
                        self.image.blit(color[cell],(15+45*(i-4),95))
                    self.howmuchhealth += 1

    def paint_money(self): pass

    def paint_active_items(self):
        resize_display = pygame.transform.scale(globs.Player.equipped["weapon"].display[0],(75,75))
        equippy = pygame.Surface((75,75)).convert()
        equippy.fill((0,0,0,0))
        equippy.set_colorkey((255,0,255))
        equippy.blit(resize_display,(0,0))
        self.image.blit(equippy,(15,400))

    def update(self):
##        self.image.blit(sidebargfx,(0,0))
        self.image.blit(graphic["sidebargfx"],(0,0))
        self.paint_health()
        self.paint_money()
        self.paint_active_items()
        globs.Surface.blit(self.image,(1000,0))

    def update_inmenu(self):
##        self.image.blit(sidebargfx,(0,0))
        self.image.blit(graphic["sidebargfx"],(0,0))
        self.paint_health()
        self.paint_money()
        self.paint_active_items()
        globs.Surface.blit(self.image,(0,0))
        
                    
                
                
    
    
    
