import pygame
import os,sys,random,math
import globs,projectile

from globs import *
from pygame.locals import *



class _Sprite:
    def __init__(self):
        self.framechoords = []
        self.frame        = 0
        self.frames       = []
        self.fps          = 15
        self.lastupdated  = 0.0
        
        self.angle = 0##

        #just for some debugging
        self.exceptiontest = 0 ##remove once fixed
        self.before_hit    = None
        self.before_direction = None
        
        
    def getframes(self,imagesheet):
        images = {}
        for i,ele in enumerate(self.framechoords):
            image = pygame.Surface((50,50)).convert_alpha()
            image.fill((0,0,0,0))
            image.blit(imagesheet,(0,0),(50*ele[0],50*ele[1],50,50))
            images[i] = image
        return images

class _Enemy(_Sprite):
    def __init__(self,loc):
        _Sprite.__init__(self)
        globs.Level.objects["enemies"].append(self)
        self.strobeupdated= 0.0
        self.dead        = False
        self.hit         = False
        self.take_damage = False
        self.busy        = False
        self.hitdie = 0   #frame number for getting hit and dieing
        self.strobe = 0   #frame number for flashing while damaged
        self.diefps = 5   #fps of the die frames
        self.thedirections = []

        self.actmidstep = False
        self.knockable  = True
        self.sleeping   = False
        self.passive    = False
        self.knockdir   = None
        self.invincible_time = 0.0

        self.direction = random.choice(DirectList)
        self.direction_removed = None ##
        self.drops = [None] #monster drops no items by default

        #set up rectangle and collision masks
        self.loc    = loc
        self.rect   = pygame.Rect(loc[0]*50,loc[1]*50,50,50)
        self.mask   = pygame.Mask((50,50))
        self.mask.fill()

        self.atk           = 1
        self.speed         = 0
        self.agro          = False
        self.agro_range    = 0
        self.originalspeed = self.speed
        self.agro_speed    = self.originalspeed

    def special(self):
        #used for special abilities in non-basic enemies
        pass

    def update(self):
        self.adjust_images()
        self.got_hit()
        if not self.hit:
            if self.speed != 0 and not self.busy: ##
                self.walking()
            if self.busy: self.special() ##
            if pygame.time.get_ticks() - self.lastupdated > 1000/5 and not self.sleeping and not self.passive:
                if self.frame == 0:
                    self.image = self.walkframes[0]
                    self.frame = 1
                else:
                    self.image = self.walkframes[1]
                    self.frame = 0
                self.lastupdated = pygame.time.get_ticks()    
        elif not self.dead:
            self.getting_hit()
        else:
            self.dieing()
        globs.Surface.blit(self.image,(self.rect))

    def get_angle(self,center = None):
        #this is used in the case that the angle between player and monster is needed
        if center == None:
            #use selfs center as the calculation point 
            xdiff = globs.Player.rect.centerx-self.rect.centerx
            ydiff = globs.Player.rect.centery-self.rect.centery
        else:
            #use another point as calculation point
            xdiff = globs.Player.rect.centerx-center[0]
            ydiff = globs.Player.rect.centery-center[1]

        try:
            if xdiff < 0:
                angle = math.atan2(-ydiff,-xdiff)
                self.angle = (angle+(math.pi/4))*(180/math.pi)
            else:
                angle = math.atan2(ydiff,xdiff)
                self.angle = (angle-(3*math.pi/4))*(180/math.pi)
        except ZeroDivisionError:
            if ydiff > 0: self.angle = (-math.pi/2+(math.pi/4))*(180/math.pi)
            else:         self.angle = (math.pi/2+(math.pi/4))*(180/math.pi)

    def adjust_images(self): pass
    
    def stepping_setup(self):
        #important for walking
        if self.speed != 0:
            self.wholesteps = int(50/self.speed)
            self.extrastep  = 50 - (self.speed*self.wholesteps)
        self.step       = 1
        self.moveit     = False
        
    def walking(self):
        if self.moveit:
            self.go_one_cell()
        elif self.do_something_else(): pass
        else:
            self.thedirections = self.mydirections()
            self.dont_leave_map()
            self.direction = random.choice(self.thedirections)
            self.getmaskchoords()

            while 1:           
                if (globs.Level.dense_solidmask.overlap_area(self.mask, (self.maskx,self.masky)) == 0 and
                    globs.Level.dense_hazmask.overlap_area(self.mask, (self.maskx,self.masky))   == 0):
                    if globs.Level.dense_watermask.overlap_area(self.mask, (self.maskx,self.masky)) == 0:
                        self.moveit = True
                        break
                    else:
                        if len(self.thedirections) == 1 and self.direction_removed != None:
                            self.direction = self.direction_removed
                            self.getmaskchoords()
                            self.direction_removed = None
                        elif self.howboutthisway() == "except": break
                else:
                        if len(self.thedirections) == 1 and self.direction_removed != None:
                            self.direction = self.direction_removed
                            self.getmaskchoords()
                            self.direction_removed = None
                        elif self.howboutthisway() == "except": break
                        

    def getmaskchoords(self):
            (self.maskx,self.masky) = (self.rect.x+(self.speed*DirectDict[self.direction][0]),
                                       self.rect.y+(self.speed*DirectDict[self.direction][1]))

    def howboutthisway(self):
        try:
            self.thedirections.remove(self.direction)                
            self.direction = random.choice(self.thedirections)
            self.getmaskchoords()
        except (IndexError,ValueError):
            #If monster steps inside a wall for whatever reason, reset them to the nearest (hopefully) empty cell.
            #This seems to be fixed, however this remains just in case it persists.
            #This section is pretty convoluted as this problem plagued me for a long time.
            #Once I can convince myself that it is truly solved I may simplify the exception handler.

            #First I attempt to reset the creature to its closest cell.
            #If after this a collission is still detected, I kick the creature back one cell in
            #the opposite direction it was originally knocked in.
            #If both these tries fail the creature auto-dies.

            #Contains a lot of error checking print lines
                            
            if   self.exceptiontest == 0: ##test code
                print("Exception caught.  So... Did it work?")
                print("Before hit,",self.before_hit,self.before_direction)
                print("supposed knock direction is,", self.knockdir)
                print("On exception your rectangle was at ,",self.rect.topleft)
            elif self.exceptiontest == 1:
                print("failed to cleanly recover from exception, creature has been murdered unjustly. You monster")
                print("choordinates were",self.rect.topleft,"before euthinasation.\n")
                self.dead = True
                self.hit  = True
                self.hitdie = 0
                
            if self.rect.x % 50 > 25:
                self.rect.x += 50 - (self.rect.x % 50)
            else:
                self.rect.x -= self.rect.x % 50
            if self.rect.y % 50 > 25:
                self.rect.y += 50 - (self.rect.y % 50)
            else:
                self.rect.y -= self.rect.y % 50

            #try this, if succesful continue like it never happened    
            if globs.Level.dense_solidmask.overlap_area(self.mask, (self.rect.x,self.rect.y)) == 0:
                if globs.Level.dense_watermask.overlap_area(self.mask, (self.rect.x,self.rect.y)) == 0:
                    self.exceptiontest = 0
                else: self.exceptiontest = 1
            else: self.exceptiontest = 1    

            #if first attempt failed, try this and pray
            if self.exceptiontest ==1:
                self.rect.x,self.rect.y = self.rect.x-50*DirectDict[self.knockdir][0],self.rect.y-50*DirectDict[self.knockdir][1]
                if globs.Level.dense_solidmask.overlap_area(self.mask, (self.rect.x,self.rect.y)) == 0:
                    if globs.Level.dense_watermask.overlap_area(self.mask, (self.rect.x,self.rect.y)) == 0:
                        self.exceptiontest = 0
                        print("recovered from exception at the last second")
                        
            if self.exceptiontest == 0: 
                print("Now your choords are,",self.rect.topleft,"\n")
            return "except"

    def go_one_cell(self):
        if self.actmidstep == True and self.do_something_else(): pass
        else:
            #take as many whole steps as speed allows in one 50*50 cell
            if self.step <= self.wholesteps:
                self.rect.x += self.speed*DirectDict[self.direction][0]
                self.rect.y += self.speed*DirectDict[self.direction][1]
                self.step   += 1
            #take one more remainder step if necessary to bring to an exact multiple of 50
            elif self.extrastep != 0:
                self.rect.x += self.extrastep*DirectDict[self.direction][0]
                self.rect.y += self.extrastep*DirectDict[self.direction][1]
                self.moveit  = False
                self.step    = 1
            #if no extra step is needed, make sure to still reupdate these
            else:
                self.moveit  = False
                self.step    = 1

    def dont_leave_map(self):
        if   self.rect.x == 0:
            while "left" in self.thedirections:                   
                self.thedirections.remove("left")
        elif self.rect.x == 950:
            while "right" in self.thedirections:
                self.thedirections.remove("right")
        if   self.rect.y == 0:
            while "back" in self.thedirections:
                self.thedirections.remove("back")
        elif self.rect.y == 650:
            while "front" in self.thedirections:
                self.thedirections.remove("front")

    def do_something_else(self):
        return 0

    def mydirections(self):
        #specific monsters should have their lists weighted if they prefer different walking styles
        if self.agro: return self.seeking()
        else: return DirectList[:]

    def seeking(self):
        #if a monster is tagged as agro it will seek out the player if withinits agro range
        xdiff = self.rect.centerx - globs.Player.rect.centerx
        ydiff = self.rect.centery - globs.Player.rect.centery

        select_directions = DirectList[:]

        if abs(xdiff) <= self.agro_range*50 and abs(ydiff) <= self.agro_range*50:
            if abs(xdiff) <= self.agro_range*50 and abs(xdiff) >= 50:
                if xdiff < 0:
                    select_directions += ["right"]*5
                else:
                    select_directions += ["left"]*5
            if abs(ydiff) <= self.agro_range*50 and abs(ydiff) >= 50:
                if ydiff < 0:
                    select_directions += ["front"]*5
                else:
                    select_directions += ["back"]*5   
            self.speed = self.agro_speed
            self.stepping_setup()
        else:
            self.speed = self.originalspeed
            self.stepping_setup()
            
        return select_directions


    def player_collission(self):
        def collision_differential():
            #calculates a differential for the colliding rectangles in the x and y axis to determine from what direction
            #a player is hit
            dx = (globs.Player.exact_mask.overlap_area(self.mask,(-globs.Player.rect.x+self.rect.x+1,-globs.Player.rect.y+self.rect.y)) -
                  globs.Player.exact_mask.overlap_area(self.mask,(-globs.Player.rect.x+self.rect.x-1,-globs.Player.rect.y+self.rect.y)))

            dy = (globs.Player.exact_mask.overlap_area(self.mask,(-globs.Player.rect.x+self.rect.x,-globs.Player.rect.y+self.rect.y+1)) -
                  globs.Player.exact_mask.overlap_area(self.mask,(-globs.Player.rect.x+self.rect.x,-globs.Player.rect.y+self.rect.y-1)))
    
            if abs(dx) > abs(dy):
                if dx > 0: knock = (1,0);  #print ("knocked right")
                else     : knock = (-1,0); #print ("knocked left")
            else:
                if dy > 0: knock = (0,1);  #print ("knocked down")
                else     : knock = (0,-1); #print ("knocked up, and he didn't even buy me dinner")
            return knock

        if self.exact_collide():
            if not self.dead and self.atk > 0  :  #don't want to be damaged and knocked around by an already deceased sprite (barring zombies perhaps)
                if pygame.time.get_ticks()-globs.Player.invincible_timer > 1000:
                    #damage is reduced by defense but currently can not be reduced below 1
                    soundfx["gethit"].play()              
                    if self. atk - globs.Player.defense > 1:
                        globs.Player.health -= (self.atk - globs.Player.defense)
                    else:
                        globs.Player.health -= 1
                    globs.Player.knockback = True
                    globs.Player.knockdir  = collision_differential()
                    globs.Player.invincible_timer = pygame.time.get_ticks()
            if globs.Player.health <= 0: globs.Player.dead = True

    def exact_collide(self):
        #if the mask of an object changes significantly at different times, calculate exact collission here
        return True
        
    def got_hit(self):
        if pygame.time.get_ticks() - self.invincible_time > 500:
            if not self.hit and globs.Player.weapon.mask.overlap_area(self.mask,(-globs.Player.weapon.rect.x+self.rect.x,-globs.Player.weapon.rect.y+self.rect.y)) != 0: ##
                #should correct the final error with monsters getting stuck in walls... hopefully.
                if self.rect.x % 50 == 0 and self.rect.y % 50 == 0: 
                    self.moveit  = False
                    self.step    = 1
                self.hit        = True
                if self.knockable:
                    self.knockdir   = globs.Player.direction
                else:
                    self.knockdir   = "none"
                self.before_hit = self.rect.topleft
                self.before_direction = self.direction
                self.invincible_time = pygame.time.get_ticks()##
        

    def getting_hit(self):
        if not self.take_damage: 
            self.health -= globs.Player.weapon.atk
            self.take_damage = True
            if self.health <= 0:
                self.dead = True
                self.hitdie = 0
                self.item_drops()
                return 0
        self.hit_logic()

    def hit_logic(self):
        self.strobing()
        #enemy knockback from player attack        
        if pygame.time.get_ticks() - self.lastupdated > 1000/30: 
                #don't let the beast be knocked off the map
                if self.hitdie % 2 == 0:
                    if   self.rect.x-50 < 0   and self.knockdir == "left" :
                        self.hitdie = 6; 
                    elif self.rect.x+50 > 950 and self.knockdir == "right":
                        self.hitdie = 6; 
                    if   self.rect.y-50 < 0   and self.knockdir == "back" :
                        self.hitdie = 6; 
                    elif self.rect.y+50 >650  and self.knockdir == "front":
                        self.hitdie = 6; 

                #please don't land in a wall    
                if self.hitdie < 6:
                    if self.hitdie % 2 == 0:
                        if (globs.Level.dense_solidmask.overlap_area(self.mask, (self.rect.x+50*DirectDict[self.knockdir][0],self.rect.y+50*DirectDict[self.knockdir][1])) == 0 and
                            globs.Level.dense_hazmask.overlap_area(self.mask, (self.rect.x+50*DirectDict[self.knockdir][0],self.rect.y+50*DirectDict[self.knockdir][1]))   == 0):
                            if globs.Level.dense_watermask.overlap_area(self.mask, (self.rect.x+50*DirectDict[self.knockdir][0],self.rect.y+50*DirectDict[self.knockdir][1])) == 0:
                                (self.rect.x,self.rect.y) = (self.rect.x + 25*DirectDict[self.knockdir][0],self.rect.y + 25*DirectDict[self.knockdir][1])
                                self.hitdie += 1
                                self.lastupdated = pygame.time.get_ticks()
                            else:
                                self.hitdie = 6
                        else:
                            self.hitdie = 6
                    else:
                        (self.rect.x,self.rect.y) = (self.rect.x + 25*DirectDict[self.knockdir][0],self.rect.y + 25*DirectDict[self.knockdir][1])
                        self.hitdie += 1
                        self.lastupdated = pygame.time.get_ticks()

        if self.strobe == 5 and self.hitdie == 6:
            self.strobe = 0; self.hitdie = 0
            self.hit    = False
            self.take_damage = False
        
    def strobing(self):
        #strobing when damaged
        if pygame.time.get_ticks() - self.strobeupdated > 1000/20:
            if self.strobe < 5:
                self.image  = self.hitframes[self.strobe%2]
                self.strobe += 1
                self.strobeupdated = pygame.time.get_ticks()

    def dieing(self):
        if pygame.time.get_ticks() - self.lastupdated > 1000/self.diefps:
            if self.hitdie < len(self.dieframes):
                self.image = self.dieframes[self.hitdie]
                self.hitdie += 1
                self.lastupdated = pygame.time.get_ticks()
            else:
                globs.Level.objects["enemies"].remove(self)
##                self.image.fill((0,0,0,0))

    def item_drops(self):
        roll_the_dice = random.choice(self.drops)
        if roll_the_dice != None:
            drop = roll_the_dice(self.rect)


class Hazard(_Enemy):
    #currently used for cactuses and probably spikes and such in the future...
    #as currently implemented they are invulnerable
    def update(self): pass
    def dieing(self): pass
    def player_collission(self):
        #had to eliminate the invulnerablility timer that regular enemies trigger so that the player can't run through a cactus
        #after taking a hit.
        def collision_differential():
            dx = (globs.Player.exact_mask.overlap_area(self.mask,(-globs.Player.rect.x+self.rect.x+1,-globs.Player.rect.y+self.rect.y)) -
                  globs.Player.exact_mask.overlap_area(self.mask,(-globs.Player.rect.x+self.rect.x-1,-globs.Player.rect.y+self.rect.y)))

            dy = (globs.Player.exact_mask.overlap_area(self.mask,(-globs.Player.rect.x+self.rect.x,-globs.Player.rect.y+self.rect.y+1)) -
                  globs.Player.exact_mask.overlap_area(self.mask,(-globs.Player.rect.x+self.rect.x,-globs.Player.rect.y+self.rect.y-1)))
    
            if abs(dx) > abs(dy):
                if dx > 0: knock = (1,0);  #print ("knocked right")
                else     : knock = (-1,0); #print ("knocked left")
            else:
                if dy > 0: knock = (0,1);  #print ("knocked down")
                else     : knock = (0,-1); #print ("knocked up, and he didn't even buy me dinner")
            return knock
        
        if not self.dead:  #don't want to be damaged and knocked around by an already deceased sprite (barring zombies perhaps)
                #damage is reduced by defense but currently can not be reduced below 1
                if self. atk - globs.Player.defense > 1:
                    globs.Player.health -= (self.atk - globs.Player.defense)
                else:
                    globs.Player.health -= 1
                globs.Player.knockback = True
                globs.Player.knockdir  = collision_differential()
        if globs.Player.health <= 0: globs.Player.dead = True


class _Item(_Sprite):
    def __init__(self):
        _Sprite.__init__(self)
        globs.Level.objects["drop_items"].append(self)
        self.born_on = pygame.time.get_ticks()
        self.duration= 15*1000

    def update(self):
        if pygame.time.get_ticks() - self.born_on < self.duration:
            if pygame.time.get_ticks() - self.lastupdated > 1000/self.fps:
                if self.frame < len(self.frames):
                    self.image = self.frames[self.frame]
                    self.frame += 1
                if self.frame == len(self.frames):
                    self.frame = 0
                self.lastupdated = pygame.time.get_ticks()    
            globs.Surface.blit(self.image,(self.rect))
        else:
            globs.Level.objects["drop_items"].remove(self)

###---specific items---###
class Heart(_Item):
    def __init__(self,location,duration="default"):
        """Duration should be given in seconds, and location is a rect"""
        _Item.__init__(self)
        if duration != "default":
            self.duration = duration*1000
        self.rect     = location
           
        self.framechoords = [(0,0),(1,0)]
        self.frames       = self.getframes(graphic["itemsheet"])
        for cell in self.frames:
            self.frames[cell] = self.frames[cell].convert()
            self.frames[cell].set_colorkey((255,0,255))
        self.mask         = pygame.mask.from_surface(self.frames[0])

    def player_collission(self):
        #sound effect here
        soundfx["heart"].play()
        if globs.Player.health + 3 < 28:
            globs.Player.health += 3
        else:
            globs.Player.health = 28
        globs.Level.objects["drop_items"].remove(self)

class Diamond(_Item):
    def __init__(self,location,duration="default"):
        """Duration should be given in seconds, and location is a rect"""
        _Item.__init__(self)
        self.fps = 7
        if duration != "default":
            self.duration = duration*1000
        self.rect     = location
        
        
        self.framechoords = [(0,1),(1,1)]
        self.frames       = self.getframes(graphic["itemsheet"])
        for cell in self.frames:
            self.frames[cell] = self.frames[cell].convert()
            self.frames[cell].set_colorkey((255,0,255))
        self.mask         = pygame.mask.from_surface(self.frames[0])

    def player_collission(self):
        #sound effect here
        globs.Player.inventory["money"] += 5 
        globs.Level.objects["drop_items"].remove(self)
        
class Antidote(_Item):
    def __init__(self,location,duration="default"):
        """Duration should be given in seconds, and location is a rect"""
        _Item.__init__(self)
        self.fps = 7
        if duration != "default":
            self.duration = duration*1000
        self.rect     = location
        
        
        self.framechoords = [(0,2),(1,2)]
        self.frames       = self.getframes(graphic["itemsheet"])
        for cell in self.frames:
            self.frames[cell] = self.frames[cell].convert()
            self.frames[cell].set_colorkey((255,0,255))
        self.mask         = pygame.mask.from_surface(self.frames[0])

    def player_collission(self):
        #sound effect here
        globs.Level.objects["drop_items"].remove(self)
        
        



###---specific enemies---###
        
class Kabetsu(_Enemy):
    """the notorious killer cabbage"""
    def __init__(self,speed,loc):
        _Enemy.__init__(self,loc)
        #basic enemy attributes
        self.health = 3 
        self.atk    = 4
        self.speed  = speed

        self.stepping_setup()

        #get all my frames and order them as needed
        self.framechoords = [(0,0),(1,0),(2,0),(3,0),(4,0),(5,0),(6,0)]
        self.frames     = self.getframes(graphic["enemysheet"])
        self.walkframes = [self.frames[0],self.frames[1]]
        self.hitframes  = [self.frames[2],self.frames[3]]
        self.dieframes  = [self.frames[4],self.frames[5],self.frames[6]]
        self.image = self.walkframes[random.randint(0,1)]

        self.drops = [Heart,None,None,None]

class Kumo(_Enemy):
    """our good friend the evil spider"""
    def __init__(self,speed,loc):
        _Enemy.__init__(self,loc)
        #basic enemy attributes
        self.health = 6 
        self.atk    = 6
        self.speed  = speed

        self.stepping_setup()

        #get all my frames and order them as needed
        self.framechoords = [(0,2),(1,2),(2,2),(3,2),(4,2),(5,2),(6,2),(7,2)]
        self.frames     = self.getframes(graphic["enemysheet"])
        self.walkframes = [self.frames[0],self.frames[1]]
        self.hitframes  = [self.frames[2],self.frames[3]]
        self.dieframes  = [self.frames[4],self.frames[5],self.frames[6],self.frames[7],self.frames[6],self.frames[7],self.frames[6]]
        self.image = self.walkframes[random.randint(0,1)]

        self.drops = [None,Diamond,None,None]

    def mydirections(self):
        #specific monsters should have their lists weighted if they prefer different walking styles
        select_directions = []
        if self.direction == "left" or self.direction == "right":
            select_directions = DirectList[:] + [self.direction]*7
            return select_directions
        else:
            return DirectList[:]


    def do_something_else(self):
        if random.randint(1,10) == 10:
            self.shot_web()
            return 1
        else:
            return 0
    
    def special(self):
        if self.busy.reallydone == True:
            self.busy = False
        
    def shot_web(self):
        if not self.busy:
            self.busy = projectile.Web(self.direction,self.rect)

class Tatsumakigame(_Enemy):
    def __init__(self,speed,loc):
        _Enemy.__init__(self,loc)
        #basic enemy attributes
        self.health = 12 
        self.atk    = 6
        self.speed  = speed
        self.stepping_setup()

        #get all my frames and order them as needed
        self.framechoords = [(0,4),(1,4),(2,4),(3,4),(4,4),(5,4)]
        self.frames     = self.getframes(graphic["enemysheet"])
        for pic in self.frames:
            self.frames[pic] = self.frames[pic].convert()
            self.frames[pic].set_colorkey((255,0,255))
        self.walkframes = [self.frames[0],self.frames[1]]
        self.hitframes  = [self.frames[2],self.frames[3]]
        self.dieframes  = [self.frames[2],self.frames[3],self.frames[4],self.frames[5],self.frames[5]]
        self.image = self.walkframes[random.randint(0,1)]

class Hebi(_Enemy):
    def __init__(self,speed,loc):
        _Enemy.__init__(self,loc)
        #basic enemy attributes
        self.health = 6 
        self.atk    = 6
        self.speed  = speed
        self.originalspeed = self.speed
        self.stepping_setup()

        self.agro = True
        self.agro_range = 20
        self.agro_speed = self.originalspeed
        

        #get all my frames and order them as needed
        self.framechoords = [(0,5),(1,5),(2,5),(3,5),(4,5),(5,5),(6,5),(7,5),(8,5)]
        self.frames     = self.getframes(graphic["enemysheet"])

        for pic in self.frames:
            self.frames[pic] = self.frames[pic].convert()
            self.frames[pic].set_colorkey((255,0,255))
        
        self.walkimages = [self.frames[0],self.frames[1],pygame.transform.flip(self.frames[0],True,False),pygame.transform.flip(self.frames[1],True,False)]
        self.walkframes = [self.frames[0],self.frames[1]]
        self.hitimages  = [self.frames[2],self.frames[3],pygame.transform.flip(self.frames[2],True,False),pygame.transform.flip(self.frames[3],True,False)]
        self.hitframes  = [self.frames[2],self.frames[3]]
        self.dieframes  = [self.frames[4],self.frames[5],self.frames[6],self.frames[7],self.frames[8]]

        self.drops = [Antidote]#,None,None,None]


    def adjust_images(self):
        if self.direction == "right":
            self.walkframes = [self.walkimages[2],self.walkimages[3]]
            self.hitframes  = [self.hitimages[2],self.hitimages[3]]
            self.dieframes  = [pygame.transform.flip(self.frames[4],True,False),pygame.transform.flip(self.frames[5],True,False),pygame.transform.flip(self.frames[6],True,False),
                               pygame.transform.flip(self.frames[7],True,False),pygame.transform.flip(self.frames[8],True,False)]
        elif self.direction == "left":
            self.walkframes = [self.walkimages[0],self.walkimages[1]]
            self.hitframes  = [self.hitimages[0],self.hitimages[1]]
            self.dieframes  = [self.frames[4],self.frames[5],self.frames[6],self.frames[7],self.frames[8]]

class Sasori(_Enemy):
    def __init__(self,speed,loc):
        _Enemy.__init__(self,loc)
        #basic enemy attributes
        self.health = 6 
        self.atk    = 10
        self.speed  = speed
        self.stepping_setup()

        #get all my frames and order them as needed
        self.framechoords = [(0,6),(1,6),(2,6),(3,6),(4,6),(5,6),(6,6),(7,6)]
        self.frames     = self.getframes(graphic["enemysheet"])

        for pic in self.frames:
            self.frames[pic] = self.frames[pic].convert()
            self.frames[pic].set_colorkey((255,0,255))
        
        self.walkimages = [self.frames[0],self.frames[1],pygame.transform.flip(self.frames[0],True,False),pygame.transform.flip(self.frames[1],True,False)]
        self.walkframes = [self.frames[0],self.frames[1]]
        self.hitimages  = [self.frames[2],self.frames[3],pygame.transform.flip(self.frames[2],True,False),pygame.transform.flip(self.frames[3],True,False)]
        self.hitframes  = [self.frames[2],self.frames[3]]
        self.dieframes  = [self.frames[4],self.frames[5],self.frames[6],self.frames[7]]


    def adjust_images(self):
        if self.direction == "right":
            self.walkframes = [self.walkimages[2],self.walkimages[3]]
            self.hitframes  = [self.hitimages[2],self.hitimages[3]]
            self.dieframes  = [pygame.transform.flip(self.frames[4],True,False),pygame.transform.flip(self.frames[5],True,False),
                               pygame.transform.flip(self.frames[6],True,False),pygame.transform.flip(self.frames[7],True,False)]
        elif self.direction == "left":
            self.walkframes = [self.walkimages[0],self.walkimages[1]]
            self.hitframes  = [self.hitimages[0],self.hitimages[1]]
            self.dieframes  = [self.frames[4],self.frames[5],self.frames[6],self.frames[7]]

class Dokuro(_Enemy):
    def __init__(self,speed,loc):
        _Enemy.__init__(self,loc)
        self.health = 6
        self.atk    = 6
        self.speed = speed
        self.oldy = None
        self.stepping_setup()

        self.spawndone = False #skeletons start as piles of bones on the ground
        self.spawnframe = 3 #skeleton dieframes backwards

        #get all my frames and order them as needed
        self.framechoords = [(0,1),(1,1),(2,1),(3,1),(4,1),(5,1),
                             (7,1),(7,0),(8,1),(8,0),(9,1),(9,0)]
        self.frames     = self.getframes(graphic["enemysheet"])

        for pic in self.frames:
            self.frames[pic] = self.frames[pic].convert()
            self.frames[pic].set_colorkey((255,0,255))

        self.walkframes = [self.frames[3],pygame.transform.flip(self.frames[3],True,False)]
        self.hitframes  = [self.frames[10],self.frames[11]]
        self.dieframes  = [self.frames[3],self.frames[4],self.frames[5]]

        self.drops = [Heart,None]
        
    def adjust_images(self):
        if self.direction != self.oldy:
            if self.direction == "left":
                self.walkframes = [self.frames[0],self.frames[1]]
                self.hitframes  = [self.frames[6],self.frames[7]]
            elif self.direction == "right":
                self.walkframes = [pygame.transform.flip(self.frames[0],True,False),pygame.transform.flip(self.frames[1],True,False)]
                self.hitframes  = [pygame.transform.flip(self.frames[6],True,False),pygame.transform.flip(self.frames[7],True,False)]
            elif self.direction == "front":
                self.walkframes = [self.frames[3],pygame.transform.flip(self.frames[3],True,False)]
                self.hitframes  = [self.frames[10],self.frames[11]]
            elif self.direction == "back":
                self.walkframes = [self.frames[2],pygame.transform.flip(self.frames[2],True,False)]
                self.hitframes  = [self.frames[8],self.frames[9]]  
            self.oldy = self.direction

    def update(self):
        if not self.spawndone:
            if pygame.time.get_ticks() - self.lastupdated > 1000/5:
                self.spawnframe -= 1
                self.lastupdated = pygame.time.get_ticks()
            if self.spawnframe < 0:
                    self.spawndone = True
                    self.image = self.walkframes[0]
            else:
                globs.Surface.blit(self.dieframes[self.spawnframe],self.rect)
        else:
            _Enemy.update(self)

    def player_collission(self):
        if not self.spawndone: pass
        else:
            _Enemy.player_collission(self)
                    
                    
    def mydirections(self):
        #specific monsters should have their lists weighted if they prefer different walking styles
        self.direction_removed = globs.DirectOps[self.direction]
        select_directions      = DirectList[:] 
        select_directions.remove(self.direction_removed)
        return select_directions
        
class MiniTanku(_Enemy):
    def __init__(self,speed,loc):
        _Enemy.__init__(self,loc)
        self.health = 6
        self.atk    = 6
        self.speed = speed
        self.oldy = None
        self.stepping_setup()

        self.actmidstep = True
        self.knockable = False
        self.diefps    = 10

        #get all my frames and order them as needed
        self.framechoords = [(0,7),(1,7),(2,7),(3,7),
                             (4,7),(5,7),(6,7),(7,7),
                             (4,8),(5,8),(6,8),(7,8),
                             (8,7),(9,7),(8,8)]
        self.frames     = self.getframes(graphic["enemysheet"])

        for pic in self.frames:
            self.frames[pic] = self.frames[pic].convert()
            self.frames[pic].set_colorkey((255,0,255))

        self.walkframes = [pygame.transform.flip(self.frames[3],False,True),pygame.transform.flip(self.frames[2],False,True)]
        self.hitframes  = [pygame.transform.flip(self.frames[4],False,True),pygame.transform.flip(self.frames[5],False,True),
                           pygame.transform.flip(self.frames[6],False,True),pygame.transform.flip(self.frames[7],False,True)]
        self.dieframes  = [self.frames[4],self.frames[5],self.frames[6],self.frames[7],self.frames[12],self.frames[13],self.frames[14],self.frames[14]]
        
    def adjust_images(self):
        if self.direction != self.oldy:
            if self.direction == "left":
                self.walkframes = [self.frames[0],self.frames[1]]
                self.hitframes  = [self.frames[8],self.frames[9],self.frames[10],self.frames[11]]
            elif self.direction == "right":
                self.walkframes = [pygame.transform.flip(self.frames[0],True,False),pygame.transform.flip(self.frames[1],True,False)]
                self.hitframes  = [pygame.transform.flip(self.frames[8] ,True,False),pygame.transform.flip(self.frames[9] ,True,False),
                                   pygame.transform.flip(self.frames[10],True,False),pygame.transform.flip(self.frames[11],True,False)]
            elif self.direction == "front":
                self.walkframes = [pygame.transform.flip(self.frames[3],False,True),pygame.transform.flip(self.frames[2],False,True)]
                self.hitframes  = [pygame.transform.flip(self.frames[4],False,True),pygame.transform.flip(self.frames[5],False,True),
                                   pygame.transform.flip(self.frames[6],False,True),pygame.transform.flip(self.frames[7],False,True)]
            elif self.direction == "back":
                self.walkframes = [self.frames[3],self.frames[2]]
                self.hitframes  = [self.frames[4],self.frames[5],self.frames[6],self.frames[7]]  
            self.oldy = self.direction

    def update(self):
            _Enemy.update(self)

    def player_collission(self):
            _Enemy.player_collission(self)
                               
    def mydirections(self):
        #specific monsters should have their lists weighted if they prefer different walking styles
        self.direction_removed = globs.DirectOps[self.direction]
        select_directions      = DirectList[:] 
        select_directions.remove(self.direction_removed)
        return select_directions

    def do_something_else(self):
        if not globs.Player.dead:
            if self.direction == "right":
                if (0 < globs.Player.rect.x - self.rect.right <= 150 and
                    globs.Player.rect.y-25 < self.rect.y < globs.Player.rect.y+25):
                    self.fire_my_lasah()
                    return 1
                else:
                    return 0
            elif self.direction == "left":
                if (0 < self.rect.x - globs.Player.rect.right <= 150 and
                    globs.Player.rect.y-25 < self.rect.y < globs.Player.rect.y+25):
                    self.fire_my_lasah()
                    return 1
                else:
                    return 0
            elif self.direction == "back":
                if (0 < self.rect.y - globs.Player.rect.bottom <= 150 and
                    globs.Player.rect.x-25 < self.rect.x < globs.Player.rect.x+25):
                    self.fire_my_lasah()
                    return 1
                else:
                    return 0
            elif self.direction == "front":
                if (0 < globs.Player.rect.y - self.rect.bottom <= 150 and
                    globs.Player.rect.x-25 < self.rect.x < globs.Player.rect.x+25):
                    self.fire_my_lasah()
                    return 1
                else:
                    return 0
        else:
            return 0
        
    def special(self):
        if self.busy.done == True:
            self.busy = False
        
    def fire_my_lasah(self):
        if not self.busy:
            #probably a good place for the sound effect
            self.busy = projectile.Laser(self.direction,self.rect)

    def strobing(self):
        #strobing when damaged
        if pygame.time.get_ticks() - self.strobeupdated > 1000/10:
            if self.strobe < 5:
                self.image  = self.hitframes[self.strobe%len(self.hitframes)]
                self.strobe += 1
                self.strobeupdated = pygame.time.get_ticks()

class Turret(_Enemy):
    def __init__(self,speed,loc):
        _Enemy.__init__(self,loc)
        self.health = 6
        self.atk    = 0
        self.speed = 0
        self.oldy = None
        self.stepping_setup()

##        self.counter = 0 #delete later
        
        self.actmidstep = True
        self.knockable = False
        self.diefps    = 10

        self.rect  = pygame.Rect(loc[0]*50,loc[1]*50-50,100,100)
        self.angle = 0.0

        self.imageraw = pygame.Surface((150,150)).convert()
        self.imageraw.blit(graphic["shootsheet"],(0,0),(0,50,150,150))
        self.imageraw.set_colorkey((255,0,255))

        self.time_between = 2 #time between shots in seconds (floats should be fine)
        self.lastupdated  = pygame.time.get_ticks()-self.time_between*random.random()*1000

    def update(self):
        if pygame.time.get_ticks() - self.lastupdated > 1.5*self.time_between*1000:
            #this if ensures that the guns don't synchronize if you go to another map
            self.lastupdated  = pygame.time.get_ticks()-self.time_between*random.random()*1000
##        def get_angle():
##            xdiff = globs.Player.rect.centerx-self.rect.centerx
##            ydiff = globs.Player.rect.centery-self.rect.centery
##
##            try:
##                if xdiff < 0:
##                    angle = math.atan(ydiff/xdiff)
##                    self.angle = (angle+(math.pi/4))*(180/math.pi)
##                else:
##                    angle = math.atan(ydiff/xdiff)
##                    self.angle = (angle-(3*math.pi/4))*(180/math.pi)
##            except ZeroDivisionError:
##                if ydiff > 0: self.angle = (-math.pi/2+(math.pi/4))*(180/math.pi)
##                else:         self.angle = (math.pi/2+(math.pi/4))*(180/math.pi)

        self.get_angle()
        self.image = pygame.transform.rotate(self.imageraw,-self.angle)
        self.newrect = self.image.get_rect()
        self.newrect.center = self.rect.center
        globs.Surface.blit(self.image,self.newrect)

        if pygame.time.get_ticks() - self.lastupdated >= self.time_between*1000:
            soundfx["laze"].play()
            projectile.Turret_Blast(self.angle,self.rect)
            self.lastupdated = pygame.time.get_ticks()

class KeroKero(_Enemy):
    def __init__(self,speed,loc):
        _Enemy.__init__(self,loc)
        self.health = 6
        self.atk    = 6
        self.speed = speed
        self.oldy = None
        self.stepping_setup()

##        self.actmidstep = True
##        self.diefps    = 10

        #get all my frames and order them as needed
        self.framechoords = [(0,11),(1,11),(0,12),(1,12),(2,12),(3,12),
                             (2,11),(3,11),
                             (4,11),(5,11),(6,11),(7,11),(8,11),(9,11),(9,12),
                             (4,12),(5,12),(6,12),(7,12)]
        self.frames     = self.getframes(graphic["enemysheet"])

        for pic in self.frames:
            self.frames[pic] = self.frames[pic].convert()
            self.frames[pic].set_colorkey((255,0,255))

        self.walkframes = [self.frames[0],self.frames[1]]
        self.hitframes  = [self.frames[6],self.frames[7]]
        self.dieframes  = [self.frames[8],self.frames[9],self.frames[10],self.frames[11],self.frames[12],self.frames[13],self.frames[14]]

    def mydirections(self):
        #specific monsters should have their lists weighted if they prefer different walking styles
        self.direction_removed = globs.DirectOps[self.direction]
        select_directions      = DirectList[:] 
        select_directions.remove(self.direction_removed)
        return select_directions
    
    def adjust_images(self):
        if self.direction != self.oldy:
            if self.direction == "right":
                self.walkframes = [self.frames[4],self.frames[5]]
                self.hitframes  = [self.frames[17],self.frames[18]]
            elif self.direction == "left":
                self.walkframes = [pygame.transform.flip(self.frames[4],True,False),pygame.transform.flip(self.frames[5],True,False)]
                self.hitframes  = [pygame.transform.flip(self.frames[17] ,True,False),pygame.transform.flip(self.frames[18] ,True,False)]
            elif self.direction == "front":
                self.walkframes = [self.frames[0],self.frames[1]]
                self.hitframes  = [self.frames[6],self.frames[7]]
            elif self.direction == "back":
                self.walkframes = [self.frames[2],self.frames[3]]
                self.hitframes  = [self.frames[15],self.frames[16]]  
            self.oldy = self.direction

class Kani(_Enemy):
    def __init__(self,speed,loc):
        _Enemy.__init__(self,loc)
        self.health = 6
        self.atk    = 6
        self.speed = speed
        self.oldy = None
        self.stepping_setup()

##        self.actmidstep = True
##        self.diefps    = 10

        #get all my frames and order them as needed
        self.framechoords = [(0,10),(1,10),
                             (2,10),(3,10),
                             (4,10),(5,10),(6,10),(7,10),(8,10)]
        self.frames     = self.getframes(graphic["enemysheet"])

        for pic in self.frames:
            self.frames[pic] = self.frames[pic].convert()
            self.frames[pic].set_colorkey((255,0,255))

        self.walkframes = [self.frames[0],self.frames[1]]
        self.hitframes  = [self.frames[2],self.frames[3]]
        self.dieframes  = [self.frames[4],self.frames[5],self.frames[6],self.frames[7],self.frames[8],self.frames[7],self.frames[8]]

    def mydirections(self):
        #specific monsters should have their lists weighted if they prefer different walking styles
        select_directions = []
        if self.direction == "left" or self.direction == "right":
            select_directions = DirectList[:] + [self.direction]*7
            return select_directions
        else:
            return DirectList[:]

class Zombie(_Enemy):
    def __init__(self,speed,loc):
        _Enemy.__init__(self,loc)
        self.health = 10
        self.atk    = 8
        self.speed = speed
        self.oldy = None
        self.stepping_setup()

##        self.actmidstep = True
##        self.diefps    = 10

        #get all my frames and order them as needed
        self.framechoords = [(0,3),(1,3),(6,4),(7,4),(8,2),(9,2),
                             (2,3),(3,3),(8,4),(9,4),(8,6),(9,6),
                             (4,3),(5,3),(6,3),(7,3),(8,3),(9,3)]
        self.frames     = self.getframes(graphic["enemysheet"])

        for pic in self.frames:
            self.frames[pic] = self.frames[pic].convert()
            self.frames[pic].set_colorkey((255,0,255))

        self.walkframes = [self.frames[0],self.frames[1]]
        self.hitframes  = [self.frames[6],self.frames[7]]
        self.dieframes  = [self.frames[12],self.frames[13],self.frames[14],self.frames[15],self.frames[16],self.frames[17],self.frames[16],self.frames[17]]

    def mydirections(self):
        #specific monsters should have their lists weighted if they prefer different walking styles
        self.direction_removed = globs.DirectOps[self.direction]
        select_directions      = DirectList[:] 
        select_directions.remove(self.direction_removed)
        return select_directions
    
    def adjust_images(self):
        if self.direction != self.oldy:
            if self.direction == "right":
                self.walkframes = [self.frames[4],self.frames[5]]
                self.hitframes  = [self.frames[10],self.frames[11]]
            elif self.direction == "left":
                self.walkframes = [pygame.transform.flip(self.frames[4],True,False),pygame.transform.flip(self.frames[5],True,False)]
                self.hitframes  = [pygame.transform.flip(self.frames[10] ,True,False),pygame.transform.flip(self.frames[11] ,True,False)]
            elif self.direction == "front":
                self.walkframes = [self.frames[0],self.frames[1]]
                self.hitframes  = [self.frames[6],self.frames[7]]
            elif self.direction == "back":
                self.walkframes = [self.frames[2],self.frames[3]]
                self.hitframes  = [self.frames[8],self.frames[9]]  
            self.oldy = self.direction

class Snail(_Enemy):
    def __init__(self,speed,loc):
        _Enemy.__init__(self,loc)
        self.health = 10
        self.atk    = 8
        self.speed = speed
        self.oldy = None
        self.stepping_setup()

##        self.actmidstep = True
##        self.diefps    = 10

        #get all my frames and order them as needed
        self.framechoords = [(0,9),(1,9),
                             (2,9),(3,9),
                             (4,9),(5,9),(6,9),(7,9),(8,9)]
        self.frames     = self.getframes(graphic["enemysheet"])

        for pic in self.frames:
            self.frames[pic] = self.frames[pic].convert()
            self.frames[pic].set_colorkey((255,0,255))

        self.walkframes = [self.frames[0],self.frames[1]]
        self.hitframes  = [self.frames[2],self.frames[3]]
        self.dieframes  = [self.frames[4],self.frames[5],self.frames[6],self.frames[7],self.frames[8],self.frames[8]]

    def mydirections(self):
        #specific monsters should have their lists weighted if they prefer different walking styles
        self.direction_removed = globs.DirectOps[self.direction]
        select_directions      = DirectList[:] 
        select_directions.remove(self.direction_removed)
        return select_directions
    
    def adjust_images(self):
        if self.direction != self.oldy:
            if self.direction == "left":
                self.walkframes = [self.frames[0],self.frames[1]]
                self.hitframes  = [self.frames[2],self.frames[3]]
                self.dieframes  = [self.frames[4],self.frames[5],self.frames[6],self.frames[7],self.frames[8],self.frames[8]]
            elif self.direction == "right":
                self.walkframes = [pygame.transform.flip(self.frames[0],True,False),pygame.transform.flip(self.frames[1],True,False)]
                self.hitframes  = [pygame.transform.flip(self.frames[2] ,True,False),pygame.transform.flip(self.frames[3] ,True,False)]
                self.dieframes  = [pygame.transform.flip(self.frames[4] ,True,False),pygame.transform.flip(self.frames[5] ,True,False),
                                   pygame.transform.flip(self.frames[6] ,True,False),pygame.transform.flip(self.frames[7] ,True,False),
                                   pygame.transform.flip(self.frames[8] ,True,False),pygame.transform.flip(self.frames[8] ,True,False)]
            self.oldy = self.direction

class Kinoki(_Enemy):
    def __init__(self,speed,loc):
        _Enemy.__init__(self,loc)
        self.health = 8
        self.atk    = 8
        self.agro_speed = speed
        self.speed     = speed
        self.oldy = None
        self.stepping_setup()
        self.speed = 0

        self.sleeping = True
        self.passive  = False
        self.passframe= 0
        self.agro       = True
        self.agro_range = 5
        self.originalspeed = 0

        
##        self.actmidstep = True
##        self.diefps    = 10

        #get all my frames and order them as needed
        self.framechoords = [(0,0),(1,0),
                             (2,0),(3,0),
                             (4,0),(5,0),
                             (6,0),(7,0),(8,0),(9,0),(9,1)]
        self.frames     = self.getframes(graphic["enemysheet1"])

        for pic in self.frames:
            self.frames[pic] = self.frames[pic].convert()
            self.frames[pic].set_colorkey((255,0,255))

        self.passiveframes = [self.frames[0],self.frames[1]]
        self.walkframes = [self.frames[2],self.frames[3]]
        self.hitframes  = [self.frames[4],self.frames[5]]
        self.dieframes  = [self.frames[6],self.frames[7],self.frames[8],self.frames[9],self.frames[10],self.frames[9],self.frames[10]]

        self.image = self.passiveframes[1]

    def getting_hit(self):
        if not self.take_damage: 
            self.health -= globs.Player.weapon.atk
            try:
                self.sleeping = False
                self.passive  = False
                self.speed    = self.agro_speed
            except AttributeError: pass
            self.take_damage = True
            if self.health <= 0:
                self.dead = True
                self.hitdie = 0
                self.item_drops()
                return 0
        self.hit_logic()
            
    def adjust_images(self):
        if self.sleeping == True:
            self.image = self.passiveframes[1]
        elif self.passive == True:
            if pygame.time.get_ticks() - self.lastupdated > 300:
                self.image = self.passiveframes[self.passframe]
                if self.passframe == 0: self.passframe = 1
                else: self.passframe = 0
                self.lastupdated = pygame.time.get_ticks()
                
        elif self.direction != self.oldy:
            if self.direction == "left":
                self.walkframes = [self.frames[2],self.frames[3]]
                self.hitframes  = [self.frames[4],self.frames[5]]
            elif self.direction == "right":
                self.walkframes = [pygame.transform.flip(self.frames[2],True,False),pygame.transform.flip(self.frames[3],True,False)]
                self.hitframes  = [pygame.transform.flip(self.frames[4],True,False),pygame.transform.flip(self.frames[5] ,True,False)]
                
            self.oldy = self.direction

    def player_collission(self):
            if self.sleeping  == True: self.sleeping = False
            elif self.passive == True: self.passive  = False
            self.speed = self.agro_speed
            _Enemy.player_collission(self)

    def seeking(self):
        xdiff = self.rect.centerx - globs.Player.rect.centerx
        ydiff = self.rect.centery - globs.Player.rect.centery
        if abs(xdiff) > self.agro_range*50 or abs(ydiff) > self.agro_range*50:
            self.passive = True
            self.speed   = 0
        return _Enemy.seeking(self)


class AoOni(_Enemy):
    def __init__(self,speed,loc):
        _Enemy.__init__(self,loc)
        self.health = 15
        self.atk    = 8
        self.speed = speed
        self.oldy = None
        self.stepping_setup()

##        self.actmidstep = True
        self.diefps    = 10

        #get all my frames and order them as needed
        self.framechoords = [(0,1),(1,1),(4,1),(7,1),(8,1),
                             (2,1),(3,1),(5,1),(0,2),(1,2),
                             (2,2),(3,2),(4,2),(5,2),(6,2),(7,2),(8,2)]
        self.frames     = self.getframes(graphic["enemysheet1"])

        for pic in self.frames:
            self.frames[pic] = self.frames[pic].convert()
            self.frames[pic].set_colorkey((255,0,255))

        self.walkframes = [self.frames[0],self.frames[1]]
        self.hitframes  = [self.frames[5],self.frames[6]]
        self.dieframes  = [self.frames[10],self.frames[11],self.frames[12],self.frames[13],self.frames[14],self.frames[15],self.frames[16]]
    
    def adjust_images(self):
        if self.direction != self.oldy:
            if self.direction == "right":
                self.walkframes = [self.frames[3],self.frames[4]]
                self.hitframes  = [self.frames[8],self.frames[9]]
            elif self.direction == "left":
                self.walkframes = [pygame.transform.flip(self.frames[3],True,False),pygame.transform.flip(self.frames[4],True,False)]
                self.hitframes  = [pygame.transform.flip(self.frames[8] ,True,False),pygame.transform.flip(self.frames[9] ,True,False)]
            elif self.direction == "front":
                self.walkframes = [self.frames[0],self.frames[1]]
                self.hitframes  = [self.frames[5],self.frames[6]]
            elif self.direction == "back":
                self.walkframes = [self.frames[2],pygame.transform.flip(self.frames[2],True,False)]
                self.hitframes  = [self.frames[7],pygame.transform.flip(self.frames[7],True,False)]  
            self.oldy = self.direction

class AkaOni(AoOni):
    def __init__(self,speed,loc):
        AoOni.__init__(self,speed,loc)
        self.framechoords = [(0,3),(1,3),(4,3),(7,3),(8,3),
                             (2,3),(3,3),(5,3),(0,4),(1,4),
                             (2,4),(3,4),(4,4),(5,4),(6,2),(7,2),(8,2)]
        self.frames     = self.getframes(graphic["enemysheet1"])

        for pic in self.frames:
            self.frames[pic] = self.frames[pic].convert()
            self.frames[pic].set_colorkey((255,0,255))

        self.walkframes = [self.frames[0],self.frames[1]]
        self.hitframes  = [self.frames[5],self.frames[6]]
        self.dieframes  = [self.frames[10],self.frames[11],self.frames[12],self.frames[13],self.frames[14],self.frames[15],self.frames[16]]

class Daruma(_Enemy):
    def __init__(self,speed,loc):
        _Enemy.__init__(self,loc)
        self.health = 6
        self.atk    = 6
        self.speed = speed
        self.oldy = None
        self.stepping_setup()

##        self.actmidstep = True
##        self.diefps    = 10

        #get all my frames and order them as needed
        self.framechoords = [(0,5),(1,5),
                             (2,5),(3,5),
                             (4,5),(5,5),(6,5),(7,5),(8,5),(9,5),(0,6),(1,6),(2,6),(3,6),(4,6),(5,6),
                             (6,4),(7,4),(8,4),(9,4)]
        self.frames     = self.getframes(graphic["enemysheet1"])

        for pic in self.frames:
            self.frames[pic] = self.frames[pic].convert()
            self.frames[pic].set_colorkey((255,0,255))

        self.walkframes = [self.frames[0],self.frames[1]]
        self.hitframes  = [self.frames[2],self.frames[3]]
        self.dieframes  = [self.frames[4],self.frames[5],self.frames[6],self.frames[7],self.frames[8],self.frames[9],self.frames[10],
                           self.frames[11],self.frames[12],self.frames[13],self.frames[14],self.frames[15]]

    def adjust_images(self):
        if self.direction != self.oldy:
            if self.direction == "front":
                self.walkframes = [self.frames[0],self.frames[1]]
                self.hitframes  = [self.frames[2],self.frames[3]]
            elif self.direction == "back":
                self.walkframes = [self.frames[16],self.frames[17]]
                self.hitframes  = [self.frames[18],self.frames[19]]
            self.oldy = self.direction

class ChochinObake(_Enemy):
    def __init__(self,speed,loc):
        _Enemy.__init__(self,loc)
        self.health = 6
        self.atk    = 6
        self.speed = speed
        self.oldy = None
        self.stepping_setup()

##        self.actmidstep = True
##        self.diefps    = 10

        #get all my frames and order them as needed
        self.framechoords = [(0,7),(1,7),
                             (6,6),(7,6),
                             (2,7),(3,7),(4,7),(5,7),(6,7),(7,7),(8,7),(9,7),(9,6)]
        self.frames     = self.getframes(graphic["enemysheet1"])

        for pic in self.frames:
            self.frames[pic] = self.frames[pic].convert()
            self.frames[pic].set_colorkey((255,0,255))

        self.walkframes = [self.frames[0],self.frames[1]]
        self.hitframes  = [self.frames[2],self.frames[3]]
        self.dieframes  = [self.frames[4],self.frames[5],self.frames[6],self.frames[7],self.frames[8],self.frames[9],self.frames[10],
                           self.frames[11],self.frames[12]]

    def adjust_images(self):
        if self.direction != self.oldy:
            if  self.direction == "right":
                self.walkframes = [self.frames[0],self.frames[1]]
                self.hitframes  = [self.frames[2],self.frames[3]]
                
            elif self.direction == "left":
                self.walkframes = [pygame.transform.flip(self.frames[0],True,False),pygame.transform.flip(self.frames[1],True,False)]
                self.hitframes  = [pygame.transform.flip(self.frames[2],True,False),pygame.transform.flip(self.frames[3],True,False)]
            self.oldy = self.direction
            
####################
EnemyDict     = {}
EnemyDict[1]  = Kabetsu
EnemyDict[2]  = Kumo
EnemyDict[3]  = Tatsumakigame
EnemyDict[4]  = Hebi
EnemyDict[5]  = Sasori
EnemyDict[6]  = Dokuro
EnemyDict[7]  = MiniTanku
EnemyDict[8]  = Turret
EnemyDict[9]  = KeroKero
EnemyDict[10] = Kani
EnemyDict[11] = Zombie
EnemyDict[12] = Snail
EnemyDict[13] = Kinoki
EnemyDict[14] = AoOni
EnemyDict[15] = AkaOni
EnemyDict[16] = Daruma
EnemyDict[17] = ChochinObake

########################

class _Boss(_Enemy):
    def __init__(self,speed,loc):
##        _Enemy.__init__(self,loc)
        _Sprite.__init__(self)
##        self.keyobject = Key
##        if globs.Player.inventory["items"]
        globs.Level.objects["bosses"].append(self) ##this is going to need to be provisional based on a flag or item

        self.strobeupdated= 0.0
        self.dead        = False
        self.hit         = False
        self.take_damage = False
        self.busy        = False
        self.hitdie = 0   #frame number for getting hit and dieing
        self.strobe = 0   #frame number for flashing while damaged
        self.diefps = 5   #fps of the die frames
        self.thedirections = []

        self.actmidstep = False
        self.knockable  = False
        self.sleeping   = False
        self.passive    = False
        self.knockdir   = None
        self.invincible_time = 0.0

        self.direction = random.choice(DirectList)
        self.direction_removed = None ##
        self.drops = [None] #monster drops no items by default

        #set up rectangle and collision masks
        self.loc    = loc
        self.bosswidth  = 50
        self.bossheight = 50

    def getbossframes(self,imagesheet):
        images = {}
        for i,ele in enumerate(self.framechoords):
            image = pygame.Surface((self.bosswidth,self.bossheight)).convert_alpha()
            image.fill((0,0,0,0))
            image.blit(imagesheet,(0,0),(self.bosswidth*ele[0],self.bossheight*ele[1],self.bosswidth,self.bossheight))
            images[i] = image
        return images

    def dieing(self):
        if pygame.time.get_ticks() - self.lastupdated > 1000/self.diefps:
            if self.hitdie < len(self.dieframes):
                self.image = self.dieframes[self.hitdie]
                self.hitdie += 1
                self.lastupdated = pygame.time.get_ticks()
            else:
                globs.Level.objects["bosses"].remove(self)
                
    def dont_leave_map(self):
        if   self.rect.x == 0:
            while "left" in self.thedirections:                   
                self.thedirections.remove("left")
        elif self.rect.x == 1000-self.bosswidth:
            while "right" in self.thedirections:
                self.thedirections.remove("right")
        if   self.rect.y == 0:
            while "back" in self.thedirections:
                self.thedirections.remove("back")
        elif self.rect.y == 700-self.bossheight:
            while "front" in self.thedirections:
                self.thedirections.remove("front")
    

class Axolotl(_Boss):
    def __init__(self,speed,loc):
##        _Enemy.__init__(self,loc)
        _Boss.__init__(self,speed,loc)
        
        self.bosswidth  = 200
        self.bossheight = 100        
        self.rect   = pygame.Rect(loc[0]*50,loc[1]*50,200,100)
        self.mask   = pygame.Mask((200,100))
        self.mask.fill()

        self.speed      = 1
        self.agro       = False
        self.agro_range = 20
        self.originalspeed = self.speed
        self.agro_speed    = 2

        self.lastshot   = 0.0##
        self.angle      = None
        self.actmidstep = True

        self.health = 27
        self.atk    = 6
        self.oldy = None
        self.stepping_setup()
        self.time_between = 2 #time between shots

        self.framechoords = [(0,0),(1,0),(0,3),(1,3),(0,6),(1,6),  #back
                             (0,1),(1,1),(0,4),(1,4),(0,7),(1,7),  #front
                             (0,2),(1,2),(0,5),(1,5),(0,8),(1,8),  #side
                             (0,9),(1,9),(0,10),(1,10)]            #shoot

        dieframechoords = []
        for y in range(4):
            for x in range(5):
                dieframechoords.append((x,y))
        
                
        self.frames       = self.getbossframes(graphic["queztlaxolotlsheet1"])
        self.framechoords = dieframechoords
        self.dieframes  = self.getbossframes(graphic["axodeath"])

        for pic in self.frames:
            self.frames[pic] = self.frames[pic].convert()
            self.frames[pic].set_colorkey((255,0,255))
        for pic in self.dieframes:
            self.dieframes[pic] = self.dieframes[pic].convert()
            self.dieframes[pic].set_colorkey((255,0,255))

        self.walkframes = [self.frames[6],self.frames[7]]
        self.hitframes  = [self.frames[8],self.frames[9]]

        self.image = self.walkframes[0]

    def exact_collide(self): 
        self.exact_mask  = pygame.mask.from_surface(self.image)
        if globs.Player.exact_mask.overlap_area(self.exact_mask, (-globs.Player.rect.x+self.rect.x,-globs.Player.rect.y+self.rect.y)) != 0:
            return 1
        else:
            return 0
        

    def getting_hit(self):
        if not self.take_damage: 
            self.health -= globs.Player.weapon.atk
            self.take_damage = True
            self.oldy = None
            self.adjust_images()
            if self.health <= 0:
                self.dead = True
                self.hitdie = 0
                self.item_drops()
                return 0
        self.hit_logic()
        
    def adjust_images(self):
        if self.direction != self.oldy:
            if self.direction == "front":
                if self.health > 18:
                    self.walkframes = [self.frames[6],self.frames[7]]
                    self.hitframes  = [self.frames[8],self.frames[9]]
                elif 18 >= self.health > 9:
                    self.walkframes = [self.frames[8],self.frames[9]]
                    self.hitframes  = [self.frames[10],self.frames[11]]
                elif  9 >= self.health:
                    self.walkframes = [self.frames[10],self.frames[11]]
                    self.hitframes  = [self.frames[10],self.frames[11]]
                
            elif self.direction == "back":
                if self.health > 18:
                    self.walkframes = [self.frames[0],self.frames[1]]
                    self.hitframes  = [self.frames[2],self.frames[3]]
                elif 18 >= self.health > 9:
                    self.walkframes = [self.frames[2],self.frames[3]]
                    self.hitframes  = [self.frames[4],self.frames[5]]
                elif 9 >= self.health:
                    self.walkframes = [self.frames[4],self.frames[5]]
                    self.hitframes  = [self.frames[4],self.frames[5]]
                    
            elif self.direction == "left":
                if self.health > 18:
                    self.walkframes = [self.frames[12],self.frames[13]]
                    self.hitframes  = [self.frames[14],self.frames[15]]
                elif 18 >= self.health > 9:
                    self.walkframes = [self.frames[14],self.frames[15]]
                    self.hitframes  = [self.frames[16],self.frames[17]]
                elif 9 >= self.health:
                    self.walkframes = [self.frames[16],self.frames[17]]
                    self.hitframes  = [self.frames[16],self.frames[17]]
                
            elif self.direction == "right":
                if self.health > 18:
                    self.walkframes = [pygame.transform.flip(self.frames[12],True,False),pygame.transform.flip(self.frames[13],True,False)]
                    self.hitframes  = [pygame.transform.flip(self.frames[14] ,True,False),pygame.transform.flip(self.frames[15] ,True,False)]    
                elif 18 >= self.health > 9:
                    self.walkframes = [pygame.transform.flip(self.frames[14],True,False),pygame.transform.flip(self.frames[15],True,False)]
                    self.hitframes  = [pygame.transform.flip(self.frames[16] ,True,False),pygame.transform.flip(self.frames[17] ,True,False)]   
                elif 9 >= self.health:
                    self.walkframes = [pygame.transform.flip(self.frames[16],True,False),pygame.transform.flip(self.frames[17],True,False)]
                    self.hitframes  = [pygame.transform.flip(self.frames[16] ,True,False),pygame.transform.flip(self.frames[17] ,True,False)]   
            self.oldy = self.direction

    def mydirections(self):
        if self.health > 18:
            return DirectList[:]
        elif 18 >= self.health > 9:
            self.direction_removed = globs.DirectOps[self.direction]
            select_directions      = DirectList[:] 
            select_directions.remove(self.direction_removed)
            return select_directions
        elif self.health <= 9:
            self.agro  = True
            return self.seeking()

        
    def do_something_else(self):
        if pygame.time.get_ticks() - self.lastshot >= self.time_between*1000:
            if 18 >= self.health > 9: 
                if ((self.direction == "left" and globs.Player.rect.x + 50 < self.rect.x)
                or  (self.direction == "right" and globs.Player.rect.x     > self.rect.x + 200)
                or  (self.direction == "front" and globs.Player.rect.y     > self.rect.y + 100)
                or  (self.direction == "back" and globs.Player.rect.y + 50 < self.rect.y)):
                    if self.direction == "left":
                        origin = pygame.Rect(0,0,50,50)
                        origin.center = (self.rect.x,self.rect.centery)
                        self.busy  = projectile.BlueFlame(self.angle,origin)
                    elif self.direction == "right":
                        origin = pygame.Rect(0,0,50,50)
                        origin.center = (self.rect.right,self.rect.centery)
                        self.busy  = projectile.BlueFlame(self.angle,origin)
                    elif self.direction == "back":
                        origin = pygame.Rect(0,0,50,50)
                        origin.center = (self.rect.centerx,self.rect.y)
                        self.busy  = projectile.BlueFlame(self.angle,origin)
                    else:
                        self.busy  = projectile.BlueFlame(self.angle,self.rect)
                    self.lastshot = pygame.time.get_ticks()
                    return 1
            elif self.health <= 9:
                if self.direction == "left":
                    origin = pygame.Rect(0,0,50,50)
                    origin.center = (self.rect.x,self.rect.centery)
                    projectile.BlueFlame(math.pi,origin)
                    projectile.BlueFlame(7*math.pi/6,origin)
                    projectile.BlueFlame(5*math.pi/6,origin)
                    projectile.BlueFlame(4*math.pi/3,origin)
                    projectile.BlueFlame(2*math.pi/3,origin)
                elif self.direction == "right":
                    origin = pygame.Rect(0,0,50,50)
                    origin.center = (self.rect.right,self.rect.centery)
                    projectile.BlueFlame(0,origin)
                    projectile.BlueFlame( math.pi/6,origin)
                    projectile.BlueFlame(-math.pi/6,origin)
                    projectile.BlueFlame( math.pi/3,origin)
                    projectile.BlueFlame(-math.pi/3,origin)
                elif self.direction == "back":
                    origin = pygame.Rect(0,0,50,50)
                    origin.center = (self.rect.centerx,self.rect.y)
                    projectile.BlueFlame(-(math.pi/2),origin)
                    projectile.BlueFlame(-(math.pi/2)+math.pi/6,origin)
                    projectile.BlueFlame(-(math.pi/2)-math.pi/6,origin)
                    projectile.BlueFlame(-(math.pi/2)+math.pi/3,origin)
                    projectile.BlueFlame(-(math.pi/2)-math.pi/3,origin)
                else:
                    projectile.BlueFlame(math.pi/2,self.rect)
                    projectile.BlueFlame(math.pi/2+math.pi/6,self.rect)
                    projectile.BlueFlame(math.pi/2-math.pi/6,self.rect)
                    projectile.BlueFlame(math.pi/2+math.pi/3,self.rect)
                    projectile.BlueFlame(math.pi/2-math.pi/3,self.rect)
                self.lastshot = pygame.time.get_ticks()
                self.busy = True
                return 1  
                    
                    
                    
        else:
            return 0
##    
    def special(self):
        self.passive = True
        if 18 >= self.health > 9:
            if self.direction == "front":
                self.image = self.frames[18]
            elif self.direction == "back":
                self.image = self.frames[2]
            elif self.direction == "left":
                self.image = self.frames[20]
            elif self.direction == "right":
                self.image = pygame.transform.flip(self.frames[20] ,True,False)
        elif self.health <=9:
            if self.direction == "front":
                self.image = self.frames[19]
            elif self.direction == "back":
                self.image = self.frames[4]
            elif self.direction == "left":
                self.image = self.frames[21]
            elif self.direction == "right":
                self.image = pygame.transform.flip(self.frames[21] ,True,False)
            
        if pygame.time.get_ticks() - self.lastshot >= 250:
            self.busy = False; self.passive = False
            self.lastshot = pygame.time.get_ticks()

    

            
#################################

BossDict      = {}
BossDict[1]   = Axolotl
                                   
                    
        














        
    
