import pygame,sys,os,pickle

try:
    import tkinter
    from tkinter import *
    from tkinter.filedialog import askopenfilename
    from tkinter.filedialog import asksaveasfilename
    from tkinter.filedialog import askdirectory
    notk = False
except ImportError:
    notk = True

import mapproc
from pygame.locals import *
from globs import *


os.environ["SDL_VIDEO_CENTERED"] = "1"
pygame.init()



class WorldMap:
    def __init__(self,directory):
        self.directory = directory
        
        self.map_images = [] #list of the map images 
        self.maplist    = [] #list of the map filenames

        self.cellchoords    = {}

        self.paintworld     = {}
        self.worlddict      = {}

        
    def maps_in_dir(self):
        #this function attempts to solve the problem of the list order changing when new maps are added
        dirlist = os.listdir(self.directory)
        try:
            self.maplist = pickle.load(open(os.path.join(self.directory,"maplist.ls"),'rb'))
        except IOError:
##            print("File not found. Starting with empty list.")
            self.maplist = []
        for item in dirlist:
            if item[-3:] == "mpt":
                if item not in self.maplist:
                    self.maplist.append(item)
                    print("Appending '",item,"'") 
                else: pass
##                    print("Sorry. List already contains this map")
        #resave the list with current changes
        filename = open(os.path.join(self.directory,"maplist.ls"),'wb')
        pickle.dump(self.maplist,filename)
        filename.close()
        
            
    def generate_maps(self):
        screen.blit(basicFont.render("Please wait while maps are generated",0,(255,255,255)),(300,250))
        pygame.display.update()
        self.maps_in_dir() ##new attempt
        for i in range(len(self.maplist)):
            self.map_images.append(pygame.Surface((1000,700)).convert_alpha())
            self.map_images[i].fill((0,0,0,0))
            
        for j,mapname in enumerate(self.maplist):
            thisMap = mapproc.AMap(self.map_images[j],pickle.load(open(os.path.join(self.directory,mapname),"rb")),mapname)
            thisMap.loadmap();thisMap.getmask();thisMap.paintfore()

    def shrink_map(self):
        screen.fill((0,0,0,0))
        screen.fill((255,0,0),(480,0,20,700))
        #the counting logic gets sloppy, but I don't care
        i = 0;j=0    
        for x,mapname in enumerate(self.maplist):
            shrunk = pygame.transform.scale(self.map_images[x], (80, 56))
            screen.blit(shrunk,(0+i*80,0+j*56))
            self.cellchoords[(i,j)] = mapname
            i+=1
            if i == 6: i = 0; j += 1
            
    def editworld(self):
        global now
        now = screen.copy()
        while True:
                click= pygame.event.wait().type
                if click == pygame.MOUSEBUTTONDOWN:
                    hit = pygame.mouse.get_pressed()
                    if hit[0]:
                        (target1,target2) = pygame.mouse.get_pos()

                        #select image from pallet
                        if 0 <= target1 <= 480 and 0 <= target2 < 650:
                            x, y = int(target1/80)*80, int(target2/56)*56
                            i, j = int(x/80),int(y/56)
                            
                            screen.blit(now,(0,0),(0,0,480,700))
                            pygame.draw.rect(screen,(255,255,0),(x,y,80,56),2)
                            pygame.display.update()

                        #paint selected image on the screen
                        elif 500 <= target1 <= 1500 and 0 <= target2 <= 700:
                            d1,d2 = int(target1/80)*80+20, int(target2/56)*56
                            f1,f2 = int((d1-20)/80)-6,int(d2/56)
                            print (f1,f2)
                            try:
                                    self.paintworld[(d1,d2)] = (screen,(x,y,80,56))
                                    self.worlddict[(f1,f2)]  = self.cellchoords[(i,j)]
                            except: print("select something you idiot")
                            paintfromdict(screen,self.paintworld)
                            pygame.display.update()

                        #saving
                        elif 50 <= target1 <= 130 and 650 <= target2 <= 700:
                            mapdata = {}
                            mapdata["paint"]       = self.paintworld
                            mapdata["world"]       = self.worlddict
                            try:
                                filename = open(asksaveasfilename(),'wb')
                                pickle.dump(mapdata,filename)
                                filename.close()
                            except IOError: pass

                        #loading
                        elif 370 <= target1 <= 470 and 650 <= target2 <= 700:
                            try:
                                loaddata = pickle.load(open(askopenfilename(filetypes=[('World Files','*.wld')]),'rb'))
                                self.worlddict  = loaddata["world"]
                                self.paintworld = loaddata["paint"]
                            except IOError: pass

                            paintfromdict(screen,self.paintworld)
                            pygame.display.update()

                    #delete a map from the working world map
                    elif hit[2]:
                        (target1,target2) = pygame.mouse.get_pos()
                        d1,d2 = int(target1/80)*80+20, int(target2/56)*56
                        f1,f2 = int((d1-20)/80)-6,int(d2/56)
                        if ((d1,d2)) in self.paintworld and 500 <= target1 <= 1500 and 0 <= target2 <= 700:
                            self.paintworld.pop((d1,d2))
                            self.worlddict.pop((f1,f2))
                            paintfromdict(screen,self.paintworld)
                            pygame.display.update()
                                

                        
                                
                                    
                if click == QUIT:
                    pygame.quit();sys.exit()

def paintfromdict(screen,paintdict):
    screen.fill((0,0,0),(500,0,1000,700))
    for key in paintdict:             
            screen.blit(now,key,paintdict[key][1])

def loadworld(land):
    loaddata = pickle.load(open(land,'rb'))
    worldmap_dict = loaddata["world"]
    return worldmap_dict



game_maps = {}
game_maps["worldmap1"] = ["maps/world",loadworld(os.path.join("maps\world","worldmap1.wld"))]
game_maps["dung1"] = ["maps/dungeons/techno",loadworld(os.path.join("maps/dungeons/techno","dung1.wld"))]
game_maps["azdung"] = ["maps/dungeons/aztempint",loadworld(os.path.join("maps/dungeons/aztempint","azdung.wld"))]

        
        




#####
if __name__ == "__main__":

    screen = pygame.display.set_mode((1500,700))
    basicFont = pygame.font.SysFont("Arial", 72)

    #initially request a directory to use maps from
    dirname = askdirectory(initialdir="maps",  title='Please select a directory')
    if dirname != "":
        world = WorldMap(dirname)
    #default to the world map if no folder is selected
    else:
        world = WorldMap("maps\world")
        
    world.generate_maps()
    world.shrink_map()
    screen.blit(graphic["levtweak"],(50,650),(0,650,400,50))
    pygame.display.update()

    world.editworld()
    
    while pygame.event.wait().type != QUIT: pass
    else: pygame.quit(); sys.exit()
